/****************************************************************
 * Copyright (c) 2003-2006, Cavium Networks. All rights reserved.
 *
 * This Software is the property of Cavium Networks.  The Software and all
 * accompanying documentation are copyrighted.  The Software made available
 * here constitutes the proprietary information of Cavium Networks.  You
 * agree to take reasonable steps to prevent the disclosure, unauthorized use
 * or unauthorized distribution of the Software.  You shall use this Software
 * solely with Cavium hardware.
 *
 * Except as expressly permitted in a separate Software License Agreement
 * between You and Cavium Networks, you shall not modify, decompile,
 * disassemble, extract, or otherwise reverse engineer this Software.  You
 * shall not make any copy of the Software or its accompanying documentation,
 * except for copying incident to the ordinary and intended use of the
 * Software and the Underlying Program and except for the making of a single
 * archival copy.
 *
 * This Software, including technical data, may be subject to U.S.  export
 * control laws, including the U.S.  Export Administration Act and its
 * associated regulations, and may be subject to export or import regulations
 * in other countries.  You warrant that You will comply strictly in all
 * respects with all such regulations and acknowledge that you have the
 * responsibility to obtain licenses to export, re-export or import the
 * Software.
 *
 * TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED "AS IS"
 * AND WITH ALL FAULTS AND CAVIUM MAKES NO PROMISES, REPRESENTATIONS OR
 * WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH RESPECT
 * TO THE SOFTWARE, INCLUDING ITS CONDITION, ITS CONFORMITY TO ANY
 * REPRESENTATION OR DESCRIPTION, OR THE EXISTENCE OF ANY LATENT OR PATENT
 * DEFECTS, AND CAVIUM SPECIFICALLY DISCLAIMS ALL IMPLIED (IF ANY) WARRANTIES
 * OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR A PARTICULAR
 * PURPOSE, LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET ENJOYMENT, QUIET
 * POSSESSION OR CORRESPONDENCE TO DESCRIPTION.  THE ENTIRE RISK ARISING OUT
 * OF USE OR PERFORMANCE OF THE SOFTWARE LIES WITH YOU.
 *
 **************************************************************************/

#ifndef __CVMX_CSR_ADDRESSES_H__
#define __CVMX_CSR_ADDRESSES_H__

#define  CVMX_ASX0_DBG_DATA_DRV                               CVMX_ADD_IO_SEG(0x00011800B0000208ull)
#define  CVMX_ASX0_DBG_DATA_ENABLE                            CVMX_ADD_IO_SEG(0x00011800B0000200ull)
#define  CVMX_ASXX_GMII_RX_CLK_SET(block_id)                 (CVMX_ADD_IO_SEG(0x00011800B0000180ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_GMII_RX_DAT_SET(block_id)                 (CVMX_ADD_IO_SEG(0x00011800B0000188ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_INT_EN(block_id)                          (CVMX_ADD_IO_SEG(0x00011800B0000018ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_INT_REG(block_id)                         (CVMX_ADD_IO_SEG(0x00011800B0000010ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_MII_RX_DAT_SET(block_id)                  (CVMX_ADD_IO_SEG(0x00011800B0000190ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_PRT_LOOP(block_id)                        (CVMX_ADD_IO_SEG(0x00011800B0000040ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_BYPASS(block_id)                      (CVMX_ADD_IO_SEG(0x00011800B0000248ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_BYPASS_SETTING(block_id)              (CVMX_ADD_IO_SEG(0x00011800B0000250ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_COMP(block_id)                        (CVMX_ADD_IO_SEG(0x00011800B0000220ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_DATA_DRV(block_id)                    (CVMX_ADD_IO_SEG(0x00011800B0000218ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_FCRAM_MODE(block_id)                  (CVMX_ADD_IO_SEG(0x00011800B0000210ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_NCTL_STRONG(block_id)                 (CVMX_ADD_IO_SEG(0x00011800B0000230ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_NCTL_WEAK(block_id)                   (CVMX_ADD_IO_SEG(0x00011800B0000240ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_PCTL_STRONG(block_id)                 (CVMX_ADD_IO_SEG(0x00011800B0000228ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_PCTL_WEAK(block_id)                   (CVMX_ADD_IO_SEG(0x00011800B0000238ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RLD_SETTING(block_id)                     (CVMX_ADD_IO_SEG(0x00011800B0000258ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_CLK_SETX(offset,block_id)              (CVMX_ADD_IO_SEG(0x00011800B0000020ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_PRT_EN(block_id)                       (CVMX_ADD_IO_SEG(0x00011800B0000000ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_WOL(block_id)                          (CVMX_ADD_IO_SEG(0x00011800B0000100ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_WOL_MSK(block_id)                      (CVMX_ADD_IO_SEG(0x00011800B0000108ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_WOL_POWOK(block_id)                    (CVMX_ADD_IO_SEG(0x00011800B0000118ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_RX_WOL_SIG(block_id)                      (CVMX_ADD_IO_SEG(0x00011800B0000110ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_TX_CLK_SETX(offset,block_id)              (CVMX_ADD_IO_SEG(0x00011800B0000048ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_TX_COMP_BYP(block_id)                     (CVMX_ADD_IO_SEG(0x00011800B0000068ull+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_TX_HI_WATERX(offset,block_id)             (CVMX_ADD_IO_SEG(0x00011800B0000080ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_ASXX_TX_PRT_EN(block_id)                       (CVMX_ADD_IO_SEG(0x00011800B0000008ull+((block_id)*0x8000000ull)))
#define  CVMX_CIU_BIST                                        CVMX_ADD_IO_SEG(0x0001070000000730ull)
#define  CVMX_CIU_DINT                                        CVMX_ADD_IO_SEG(0x0001070000000720ull)
#define  CVMX_CIU_FUSE                                        CVMX_ADD_IO_SEG(0x0001070000000728ull)
#define  CVMX_CIU_GSTOP                                       CVMX_ADD_IO_SEG(0x0001070000000710ull)
#define  CVMX_CIU_INTX_EN0(offset)                           (CVMX_ADD_IO_SEG(0x0001070000000200ull+((offset)*16)))
#define  CVMX_CIU_INTX_EN1(offset)                           (CVMX_ADD_IO_SEG(0x0001070000000208ull+((offset)*16)))
#define  CVMX_CIU_INTX_EN4_0(offset)                         (CVMX_ADD_IO_SEG(0x0001070000000C80ull+((offset)*16)))
#define  CVMX_CIU_INTX_EN4_1(offset)                         (CVMX_ADD_IO_SEG(0x0001070000000C88ull+((offset)*16)))
#define  CVMX_CIU_INTX_SUM0(offset)                          (CVMX_ADD_IO_SEG(0x0001070000000000ull+((offset)*8)))
#define  CVMX_CIU_INTX_SUM4(offset)                          (CVMX_ADD_IO_SEG(0x0001070000000C00ull+((offset)*8)))
#define  CVMX_CIU_INT_SUM1                                    CVMX_ADD_IO_SEG(0x0001070000000108ull)
#define  CVMX_CIU_MBOX_CLRX(offset)                          (CVMX_ADD_IO_SEG(0x0001070000000680ull+((offset)*8)))
#define  CVMX_CIU_MBOX_SETX(offset)                          (CVMX_ADD_IO_SEG(0x0001070000000600ull+((offset)*8)))
#define  CVMX_CIU_NMI                                         CVMX_ADD_IO_SEG(0x0001070000000718ull)
#define  CVMX_CIU_PCI_INTA                                    CVMX_ADD_IO_SEG(0x0001070000000750ull)
#define  CVMX_CIU_PP_DBG                                      CVMX_ADD_IO_SEG(0x0001070000000708ull)
#define  CVMX_CIU_PP_POKEX(offset)                           (CVMX_ADD_IO_SEG(0x0001070000000580ull+((offset)*8)))
#define  CVMX_CIU_PP_RST                                      CVMX_ADD_IO_SEG(0x0001070000000700ull)
#define  CVMX_CIU_SOFT_BIST                                   CVMX_ADD_IO_SEG(0x0001070000000738ull)
#define  CVMX_CIU_SOFT_PRST                                   CVMX_ADD_IO_SEG(0x0001070000000748ull)
#define  CVMX_CIU_SOFT_RST                                    CVMX_ADD_IO_SEG(0x0001070000000740ull)
#define  CVMX_CIU_TIMX(offset)                               (CVMX_ADD_IO_SEG(0x0001070000000480ull+((offset)*8)))
#define  CVMX_CIU_WDOGX(offset)                              (CVMX_ADD_IO_SEG(0x0001070000000500ull+((offset)*8)))
#define  CVMX_DBG_DATA                                        CVMX_ADD_IO_SEG(0x00011F00000001E8ull)
#define  CVMX_DFA_BST0                                        CVMX_ADD_IO_SEG(0x00011800300007F0ull)
#define  CVMX_DFA_BST1                                        CVMX_ADD_IO_SEG(0x00011800300007F8ull)
#define  CVMX_DFA_CFG                                         CVMX_ADD_IO_SEG(0x0001180030000000ull)
#define  CVMX_DFA_DBELL                                       CVMX_ADD_IO_SEG(0x0001370000000000ull)
#define  CVMX_DFA_DDR2_ADDR                                   CVMX_ADD_IO_SEG(0x0001180030000210ull)
#define  CVMX_DFA_DDR2_BUS                                    CVMX_ADD_IO_SEG(0x0001180030000080ull)
#define  CVMX_DFA_DDR2_CFG                                    CVMX_ADD_IO_SEG(0x0001180030000208ull)
#define  CVMX_DFA_DDR2_COMP                                   CVMX_ADD_IO_SEG(0x0001180030000090ull)
#define  CVMX_DFA_DDR2_EMRS                                   CVMX_ADD_IO_SEG(0x0001180030000268ull)
#define  CVMX_DFA_DDR2_FCNT                                   CVMX_ADD_IO_SEG(0x0001180030000078ull)
#define  CVMX_DFA_DDR2_MRS                                    CVMX_ADD_IO_SEG(0x0001180030000260ull)
#define  CVMX_DFA_DDR2_OPT                                    CVMX_ADD_IO_SEG(0x0001180030000070ull)
#define  CVMX_DFA_DDR2_PLL                                    CVMX_ADD_IO_SEG(0x0001180030000088ull)
#define  CVMX_DFA_DDR2_TMG                                    CVMX_ADD_IO_SEG(0x0001180030000218ull)
#define  CVMX_DFA_DIFCTL                                      CVMX_ADD_IO_SEG(0x0001370600000000ull)
#define  CVMX_DFA_DIFRDPTR                                    CVMX_ADD_IO_SEG(0x0001370200000000ull)
#define  CVMX_DFA_ECLKCFG                                     CVMX_ADD_IO_SEG(0x0001180030000200ull)
#define  CVMX_DFA_ERR                                         CVMX_ADD_IO_SEG(0x0001180030000028ull)
#define  CVMX_DFA_MEMCFG0                                     CVMX_ADD_IO_SEG(0x0001180030000008ull)
#define  CVMX_DFA_MEMCFG1                                     CVMX_ADD_IO_SEG(0x0001180030000010ull)
#define  CVMX_DFA_MEMCFG2                                     CVMX_ADD_IO_SEG(0x0001180030000060ull)
#define  CVMX_DFA_MEMFADR                                     CVMX_ADD_IO_SEG(0x0001180030000030ull)
#define  CVMX_DFA_MEMFCR                                      CVMX_ADD_IO_SEG(0x0001180030000038ull)
#define  CVMX_DFA_MEMRLD                                      CVMX_ADD_IO_SEG(0x0001180030000018ull)
#define  CVMX_DFA_NCBCTL                                      CVMX_ADD_IO_SEG(0x0001180030000020ull)
#define  CVMX_DFA_RODT_COMP_CTL                               CVMX_ADD_IO_SEG(0x0001180030000098ull)
#define  CVMX_DFA_SBD_DBG0                                    CVMX_ADD_IO_SEG(0x0001180030000040ull)
#define  CVMX_DFA_SBD_DBG1                                    CVMX_ADD_IO_SEG(0x0001180030000048ull)
#define  CVMX_DFA_SBD_DBG2                                    CVMX_ADD_IO_SEG(0x0001180030000050ull)
#define  CVMX_DFA_SBD_DBG3                                    CVMX_ADD_IO_SEG(0x0001180030000058ull)
#define  CVMX_FPA_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00011800280000E8ull)
#define  CVMX_FPA_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x0001180028000050ull)
#define  CVMX_FPA_FPF0_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000000ull)
#define  CVMX_FPA_FPF0_SIZE                                   CVMX_ADD_IO_SEG(0x0001180028000058ull)
#define  CVMX_FPA_FPF1_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000008ull)
#define  CVMX_FPA_FPF2_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000010ull)
#define  CVMX_FPA_FPF3_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000018ull)
#define  CVMX_FPA_FPF4_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000020ull)
#define  CVMX_FPA_FPF5_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000028ull)
#define  CVMX_FPA_FPF6_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000030ull)
#define  CVMX_FPA_FPF7_MARKS                                  CVMX_ADD_IO_SEG(0x0001180028000038ull)
#define  CVMX_FPA_FPFX_SIZE(offset)                          (CVMX_ADD_IO_SEG(0x0001180028000060ull+((offset)*8)-8*1))
#define  CVMX_FPA_INT_ENB                                     CVMX_ADD_IO_SEG(0x0001180028000048ull)
#define  CVMX_FPA_INT_SUM                                     CVMX_ADD_IO_SEG(0x0001180028000040ull)
#define  CVMX_FPA_QUE0_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x00011800280000F0ull)
#define  CVMX_FPA_QUE1_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x00011800280000F8ull)
#define  CVMX_FPA_QUE2_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000100ull)
#define  CVMX_FPA_QUE3_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000108ull)
#define  CVMX_FPA_QUE4_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000110ull)
#define  CVMX_FPA_QUE5_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000118ull)
#define  CVMX_FPA_QUE6_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000120ull)
#define  CVMX_FPA_QUE7_PAGE_INDEX                             CVMX_ADD_IO_SEG(0x0001180028000128ull)
#define  CVMX_FPA_QUEX_AVAILABLE(offset)                     (CVMX_ADD_IO_SEG(0x0001180028000098ull+((offset)*8)))
#define  CVMX_FPA_QUE_ACT                                     CVMX_ADD_IO_SEG(0x0001180028000138ull)
#define  CVMX_FPA_QUE_EXP                                     CVMX_ADD_IO_SEG(0x0001180028000130ull)
#define  CVMX_FPA_WART_CTL                                    CVMX_ADD_IO_SEG(0x00011800280000D8ull)
#define  CVMX_FPA_WART_STATUS                                 CVMX_ADD_IO_SEG(0x00011800280000E0ull)
#define  CVMX_GMXX_BAD_REG(block_id)                         (CVMX_ADD_IO_SEG(0x0001180008000518ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_BIST(block_id)                            (CVMX_ADD_IO_SEG(0x0001180008000400ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_INF_MODE(block_id)                        (CVMX_ADD_IO_SEG(0x00011800080007F8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_NXA_ADR(block_id)                         (CVMX_ADD_IO_SEG(0x0001180008000510ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_PRTX_CFG(offset,block_id)                 (CVMX_ADD_IO_SEG(0x0001180008000010ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM0(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000180ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM1(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000188ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM2(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000190ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM3(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000198ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM4(offset,block_id)             (CVMX_ADD_IO_SEG(0x00011800080001A0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM5(offset,block_id)             (CVMX_ADD_IO_SEG(0x00011800080001A8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CAM_EN(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000108ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_ADR_CTL(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000100ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_DECISION(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000040ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_FRM_CHK(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000020ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_FRM_CTL(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000018ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_FRM_MAX(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000030ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_FRM_MIN(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000028ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_IFG(offset,block_id)                  (CVMX_ADD_IO_SEG(0x0001180008000058ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_INT_EN(offset,block_id)               (CVMX_ADD_IO_SEG(0x0001180008000008ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_INT_REG(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000000ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_JABBER(offset,block_id)               (CVMX_ADD_IO_SEG(0x0001180008000038ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_PAUSE_DROP_TIME(offset,block_id)      (CVMX_ADD_IO_SEG(0x0001180008000068ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_RX_INBND(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000060ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_CTL(offset,block_id)            (CVMX_ADD_IO_SEG(0x0001180008000050ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_OCTS(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000088ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_OCTS_CTL(offset,block_id)       (CVMX_ADD_IO_SEG(0x0001180008000098ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_OCTS_DMAC(offset,block_id)      (CVMX_ADD_IO_SEG(0x00011800080000A8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_OCTS_DRP(offset,block_id)       (CVMX_ADD_IO_SEG(0x00011800080000B8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_PKTS(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000080ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_PKTS_BAD(offset,block_id)       (CVMX_ADD_IO_SEG(0x00011800080000C0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_PKTS_CTL(offset,block_id)       (CVMX_ADD_IO_SEG(0x0001180008000090ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_PKTS_DMAC(offset,block_id)      (CVMX_ADD_IO_SEG(0x00011800080000A0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_STATS_PKTS_DRP(offset,block_id)       (CVMX_ADD_IO_SEG(0x00011800080000B0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RXX_UDD_SKP(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000048ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_BP_DROPX(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000420ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_BP_OFFX(offset,block_id)               (CVMX_ADD_IO_SEG(0x0001180008000460ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_BP_ONX(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000440ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_PASS_EN(block_id)                      (CVMX_ADD_IO_SEG(0x00011800080005F8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_PASS_MAPX(offset,block_id)             (CVMX_ADD_IO_SEG(0x0001180008000600ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_PRTS(block_id)                         (CVMX_ADD_IO_SEG(0x0001180008000410ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_PRT_INFO(block_id)                     (CVMX_ADD_IO_SEG(0x00011800080004E8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_RX_TX_STATUS(block_id)                    (CVMX_ADD_IO_SEG(0x00011800080007E8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_SMACX(offset,block_id)                    (CVMX_ADD_IO_SEG(0x0001180008000230ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_STAT_BP(block_id)                         (CVMX_ADD_IO_SEG(0x0001180008000520ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_APPEND(offset,block_id)               (CVMX_ADD_IO_SEG(0x0001180008000218ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_BURST(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000228ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_CLK(offset,block_id)                  (CVMX_ADD_IO_SEG(0x0001180008000208ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_CTL(offset,block_id)                  (CVMX_ADD_IO_SEG(0x0001180008000270ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_MIN_PKT(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000240ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_PAUSE_PKT_INTERVAL(offset,block_id)   (CVMX_ADD_IO_SEG(0x0001180008000248ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_PAUSE_PKT_TIME(offset,block_id)       (CVMX_ADD_IO_SEG(0x0001180008000238ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_PAUSE_TOGO(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000258ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_PAUSE_ZERO(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000260ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_SLOT(offset,block_id)                 (CVMX_ADD_IO_SEG(0x0001180008000220ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_SOFT_PAUSE(offset,block_id)           (CVMX_ADD_IO_SEG(0x0001180008000250ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT0(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000280ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT1(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000288ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT2(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000290ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT3(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180008000298ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT4(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002A0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT5(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002A8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT6(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002B0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT7(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002B8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT8(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002C0ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STAT9(offset,block_id)                (CVMX_ADD_IO_SEG(0x00011800080002C8ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_STATS_CTL(offset,block_id)            (CVMX_ADD_IO_SEG(0x0001180008000268ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TXX_THRESH(offset,block_id)               (CVMX_ADD_IO_SEG(0x0001180008000210ull+((offset)*2048)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_BP(block_id)                           (CVMX_ADD_IO_SEG(0x00011800080004D0ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_CLK_MSKX(offset,block_id)              (CVMX_ADD_IO_SEG(0x0001180008000780ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_COL_ATTEMPT(block_id)                  (CVMX_ADD_IO_SEG(0x0001180008000498ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_CORRUPT(block_id)                      (CVMX_ADD_IO_SEG(0x00011800080004D8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_IFG(block_id)                          (CVMX_ADD_IO_SEG(0x0001180008000488ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_INT_EN(block_id)                       (CVMX_ADD_IO_SEG(0x0001180008000508ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_INT_REG(block_id)                      (CVMX_ADD_IO_SEG(0x0001180008000500ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_JAM(block_id)                          (CVMX_ADD_IO_SEG(0x0001180008000490ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_LFSR(block_id)                         (CVMX_ADD_IO_SEG(0x00011800080004F8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_OVR_BP(block_id)                       (CVMX_ADD_IO_SEG(0x00011800080004C8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_PAUSE_PKT_DMAC(block_id)               (CVMX_ADD_IO_SEG(0x00011800080004A0ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_PAUSE_PKT_TYPE(block_id)               (CVMX_ADD_IO_SEG(0x00011800080004A8ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_PRTS(block_id)                         (CVMX_ADD_IO_SEG(0x0001180008000480ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_SPI_CTL(block_id)                      (CVMX_ADD_IO_SEG(0x00011800080004C0ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_SPI_DRAIN(block_id)                    (CVMX_ADD_IO_SEG(0x00011800080004E0ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_SPI_MAX(block_id)                      (CVMX_ADD_IO_SEG(0x00011800080004B0ull+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_SPI_ROUNDX(offset,block_id)            (CVMX_ADD_IO_SEG(0x0001180008000680ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_GMXX_TX_SPI_THRESH(block_id)                   (CVMX_ADD_IO_SEG(0x00011800080004B8ull+((block_id)*0x8000000ull)))
#define  CVMX_GPIO_BIT_CFGX(offset)                          (CVMX_ADD_IO_SEG(0x0001070000000800ull+((offset)*8)))
#define  CVMX_GPIO_BOOT_ENA                                   CVMX_ADD_IO_SEG(0x00010700000008A8ull)
#define  CVMX_GPIO_DBG_ENA                                    CVMX_ADD_IO_SEG(0x00010700000008A0ull)
#define  CVMX_GPIO_INT_CLR                                    CVMX_ADD_IO_SEG(0x0001070000000898ull)
#define  CVMX_GPIO_RX_DAT                                     CVMX_ADD_IO_SEG(0x0001070000000880ull)
#define  CVMX_GPIO_TX_CLR                                     CVMX_ADD_IO_SEG(0x0001070000000890ull)
#define  CVMX_GPIO_TX_SET                                     CVMX_ADD_IO_SEG(0x0001070000000888ull)
#define  CVMX_GPIO_XBIT_CFGX(offset)                         (CVMX_ADD_IO_SEG(0x0001070000000900ull+((offset)*8)-8*16))
#define  CVMX_IOB_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00011800F00007F8ull)
#define  CVMX_IOB_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x00011800F0000050ull)
#define  CVMX_IOB_DWB_PRI_CNT                                 CVMX_ADD_IO_SEG(0x00011800F0000028ull)
#define  CVMX_IOB_FAU_TIMEOUT                                 CVMX_ADD_IO_SEG(0x00011800F0000000ull)
#define  CVMX_IOB_I2C_PRI_CNT                                 CVMX_ADD_IO_SEG(0x00011800F0000010ull)
#define  CVMX_IOB_INB_CONTROL_MATCH                           CVMX_ADD_IO_SEG(0x00011800F0000078ull)
#define  CVMX_IOB_INB_CONTROL_MATCH_ENB                       CVMX_ADD_IO_SEG(0x00011800F0000088ull)
#define  CVMX_IOB_INB_DATA_MATCH                              CVMX_ADD_IO_SEG(0x00011800F0000070ull)
#define  CVMX_IOB_INB_DATA_MATCH_ENB                          CVMX_ADD_IO_SEG(0x00011800F0000080ull)
#define  CVMX_IOB_INT_ENB                                     CVMX_ADD_IO_SEG(0x00011800F0000060ull)
#define  CVMX_IOB_INT_SUM                                     CVMX_ADD_IO_SEG(0x00011800F0000058ull)
#define  CVMX_IOB_N2C_L2C_PRI_CNT                             CVMX_ADD_IO_SEG(0x00011800F0000020ull)
#define  CVMX_IOB_N2C_RSP_PRI_CNT                             CVMX_ADD_IO_SEG(0x00011800F0000008ull)
#define  CVMX_IOB_OUTB_COM_PRI_CNT                            CVMX_ADD_IO_SEG(0x00011800F0000040ull)
#define  CVMX_IOB_OUTB_CONTROL_MATCH                          CVMX_ADD_IO_SEG(0x00011800F0000098ull)
#define  CVMX_IOB_OUTB_CONTROL_MATCH_ENB                      CVMX_ADD_IO_SEG(0x00011800F00000A8ull)
#define  CVMX_IOB_OUTB_DATA_MATCH                             CVMX_ADD_IO_SEG(0x00011800F0000090ull)
#define  CVMX_IOB_OUTB_DATA_MATCH_ENB                         CVMX_ADD_IO_SEG(0x00011800F00000A0ull)
#define  CVMX_IOB_OUTB_FPA_PRI_CNT                            CVMX_ADD_IO_SEG(0x00011800F0000048ull)
#define  CVMX_IOB_OUTB_REQ_PRI_CNT                            CVMX_ADD_IO_SEG(0x00011800F0000038ull)
#define  CVMX_IOB_P2C_REQ_PRI_CNT                             CVMX_ADD_IO_SEG(0x00011800F0000018ull)
#define  CVMX_IOB_PKT_ERR                                     CVMX_ADD_IO_SEG(0x00011800F0000068ull)
#define  CVMX_IPD_1ST_MBUFF_SKIP                              CVMX_ADD_IO_SEG(0x00014F0000000000ull)
#define  CVMX_IPD_1st_NEXT_PTR_BACK                           CVMX_ADD_IO_SEG(0x00014F0000000150ull)
#define  CVMX_IPD_2nd_NEXT_PTR_BACK                           CVMX_ADD_IO_SEG(0x00014F0000000158ull)
#define  CVMX_IPD_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00014F00000007F8ull)
#define  CVMX_IPD_BP_PRT_RED_END                              CVMX_ADD_IO_SEG(0x00014F0000000328ull)
#define  CVMX_IPD_CLK_COUNT                                   CVMX_ADD_IO_SEG(0x00014F0000000338ull)
#define  CVMX_IPD_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x00014F0000000018ull)
#define  CVMX_IPD_INT_ENB                                     CVMX_ADD_IO_SEG(0x00014F0000000160ull)
#define  CVMX_IPD_INT_SUM                                     CVMX_ADD_IO_SEG(0x00014F0000000168ull)
#define  CVMX_IPD_NOT_1ST_MBUFF_SKIP                          CVMX_ADD_IO_SEG(0x00014F0000000008ull)
#define  CVMX_IPD_PACKET_MBUFF_SIZE                           CVMX_ADD_IO_SEG(0x00014F0000000010ull)
#define  CVMX_IPD_PKT_PTR_VALID                               CVMX_ADD_IO_SEG(0x00014F0000000358ull)
#define  CVMX_IPD_PORTX_BP_PAGE_CNT(offset)                  (CVMX_ADD_IO_SEG(0x00014F0000000028ull+((offset)*8)))
#define  CVMX_IPD_PORT_BP_COUNTERS_PAIRX(offset)             (CVMX_ADD_IO_SEG(0x00014F00000001B8ull+((offset)*8)))
#define  CVMX_IPD_PRC_HOLD_PTR_FIFO_CTL                       CVMX_ADD_IO_SEG(0x00014F0000000348ull)
#define  CVMX_IPD_PRC_PORT_PTR_FIFO_CTL                       CVMX_ADD_IO_SEG(0x00014F0000000350ull)
#define  CVMX_IPD_PTR_COUNT                                   CVMX_ADD_IO_SEG(0x00014F0000000320ull)
#define  CVMX_IPD_PWP_PTR_FIFO_CTL                            CVMX_ADD_IO_SEG(0x00014F0000000340ull)
#define  CVMX_IPD_QOS0_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F0000000178ull)
#define  CVMX_IPD_QOS1_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F0000000180ull)
#define  CVMX_IPD_QOS2_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F0000000188ull)
#define  CVMX_IPD_QOS3_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F0000000190ull)
#define  CVMX_IPD_QOS4_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F0000000198ull)
#define  CVMX_IPD_QOS5_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F00000001A0ull)
#define  CVMX_IPD_QOS6_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F00000001A8ull)
#define  CVMX_IPD_QOS7_RED_MARKS                              CVMX_ADD_IO_SEG(0x00014F00000001B0ull)
#define  CVMX_IPD_QUE0_FREE_PAGE_CNT                          CVMX_ADD_IO_SEG(0x00014F0000000330ull)
#define  CVMX_IPD_RED_PORT_ENABLE                             CVMX_ADD_IO_SEG(0x00014F00000002D8ull)
#define  CVMX_IPD_RED_QUE0_PARAM                              CVMX_ADD_IO_SEG(0x00014F00000002E0ull)
#define  CVMX_IPD_RED_QUE1_PARAM                              CVMX_ADD_IO_SEG(0x00014F00000002E8ull)
#define  CVMX_IPD_RED_QUE2_PARAM                              CVMX_ADD_IO_SEG(0x00014F00000002F0ull)
#define  CVMX_IPD_RED_QUE3_PARAM                              CVMX_ADD_IO_SEG(0x00014F00000002F8ull)
#define  CVMX_IPD_RED_QUE4_PARAM                              CVMX_ADD_IO_SEG(0x00014F0000000300ull)
#define  CVMX_IPD_RED_QUE5_PARAM                              CVMX_ADD_IO_SEG(0x00014F0000000308ull)
#define  CVMX_IPD_RED_QUE6_PARAM                              CVMX_ADD_IO_SEG(0x00014F0000000310ull)
#define  CVMX_IPD_RED_QUE7_PARAM                              CVMX_ADD_IO_SEG(0x00014F0000000318ull)
#define  CVMX_IPD_SUB_PORT_BP_PAGE_CNT                        CVMX_ADD_IO_SEG(0x00014F0000000148ull)
#define  CVMX_IPD_SUB_PORT_FCS                                CVMX_ADD_IO_SEG(0x00014F0000000170ull)
#define  CVMX_IPD_WQE_FPA_QUEUE                               CVMX_ADD_IO_SEG(0x00014F0000000020ull)
#define  CVMX_IPD_WQE_PTR_VALID                               CVMX_ADD_IO_SEG(0x00014F0000000360ull)
#define  CVMX_KEY_BIST_REG                                    CVMX_ADD_IO_SEG(0x0001180020000018ull)
#define  CVMX_KEY_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x0001180020000010ull)
#define  CVMX_KEY_INT_ENB                                     CVMX_ADD_IO_SEG(0x0001180020000008ull)
#define  CVMX_KEY_INT_SUM                                     CVMX_ADD_IO_SEG(0x0001180020000000ull)
#define  CVMX_L2C_BST0                                        CVMX_ADD_IO_SEG(0x00011800800007F8ull)
#define  CVMX_L2C_BST1                                        CVMX_ADD_IO_SEG(0x00011800800007F0ull)
#define  CVMX_L2C_BST2                                        CVMX_ADD_IO_SEG(0x00011800800007E8ull)
#define  CVMX_L2C_CFG                                         CVMX_ADD_IO_SEG(0x0001180080000000ull)
#define  CVMX_L2C_DBG                                         CVMX_ADD_IO_SEG(0x0001180080000030ull)
#define  CVMX_L2C_DUT                                         CVMX_ADD_IO_SEG(0x0001180080000050ull)
#define  CVMX_L2C_LCKBASE                                     CVMX_ADD_IO_SEG(0x0001180080000058ull)
#define  CVMX_L2C_LCKOFF                                      CVMX_ADD_IO_SEG(0x0001180080000060ull)
#define  CVMX_L2C_LFB0                                        CVMX_ADD_IO_SEG(0x0001180080000038ull)
#define  CVMX_L2C_LFB1                                        CVMX_ADD_IO_SEG(0x0001180080000040ull)
#define  CVMX_L2C_LFB2                                        CVMX_ADD_IO_SEG(0x0001180080000048ull)
#define  CVMX_L2C_LFB3                                        CVMX_ADD_IO_SEG(0x00011800800000B8ull)
#define  CVMX_L2C_PFC0                                        CVMX_ADD_IO_SEG(0x0001180080000098ull)
#define  CVMX_L2C_PFC1                                        CVMX_ADD_IO_SEG(0x00011800800000A0ull)
#define  CVMX_L2C_PFC2                                        CVMX_ADD_IO_SEG(0x00011800800000A8ull)
#define  CVMX_L2C_PFC3                                        CVMX_ADD_IO_SEG(0x00011800800000B0ull)
#define  CVMX_L2C_PFCTL                                       CVMX_ADD_IO_SEG(0x0001180080000090ull)
#define  CVMX_L2C_SPAR0                                       CVMX_ADD_IO_SEG(0x0001180080000068ull)
#define  CVMX_L2C_SPAR1                                       CVMX_ADD_IO_SEG(0x0001180080000070ull)
#define  CVMX_L2C_SPAR2                                       CVMX_ADD_IO_SEG(0x0001180080000078ull)
#define  CVMX_L2C_SPAR3                                       CVMX_ADD_IO_SEG(0x0001180080000080ull)
#define  CVMX_L2C_SPAR4                                       CVMX_ADD_IO_SEG(0x0001180080000088ull)
#define  CVMX_L2D_BST0                                        CVMX_ADD_IO_SEG(0x0001180080000780ull)
#define  CVMX_L2D_BST1                                        CVMX_ADD_IO_SEG(0x0001180080000788ull)
#define  CVMX_L2D_BST2                                        CVMX_ADD_IO_SEG(0x0001180080000790ull)
#define  CVMX_L2D_BST3                                        CVMX_ADD_IO_SEG(0x0001180080000798ull)
#define  CVMX_L2D_ERR                                         CVMX_ADD_IO_SEG(0x0001180080000010ull)
#define  CVMX_L2D_FADR                                        CVMX_ADD_IO_SEG(0x0001180080000018ull)
#define  CVMX_L2D_FSYN0                                       CVMX_ADD_IO_SEG(0x0001180080000020ull)
#define  CVMX_L2D_FSYN1                                       CVMX_ADD_IO_SEG(0x0001180080000028ull)
#define  CVMX_L2D_FUS0                                        CVMX_ADD_IO_SEG(0x00011800800007A0ull)
#define  CVMX_L2D_FUS1                                        CVMX_ADD_IO_SEG(0x00011800800007A8ull)
#define  CVMX_L2D_FUS2                                        CVMX_ADD_IO_SEG(0x00011800800007B0ull)
#define  CVMX_L2D_FUS3                                        CVMX_ADD_IO_SEG(0x00011800800007B8ull)
#define  CVMX_L2T_ERR                                         CVMX_ADD_IO_SEG(0x0001180080000008ull)
#define  CVMX_LED_BLINK                                       CVMX_ADD_IO_SEG(0x0001180000001A48ull)
#define  CVMX_LED_CLK_PHASE                                   CVMX_ADD_IO_SEG(0x0001180000001A08ull)
#define  CVMX_LED_CYLON                                       CVMX_ADD_IO_SEG(0x0001180000001AF8ull)
#define  CVMX_LED_DBG                                         CVMX_ADD_IO_SEG(0x0001180000001A18ull)
#define  CVMX_LED_EN                                          CVMX_ADD_IO_SEG(0x0001180000001A00ull)
#define  CVMX_LED_POLARITY                                    CVMX_ADD_IO_SEG(0x0001180000001A50ull)
#define  CVMX_LED_PRT                                         CVMX_ADD_IO_SEG(0x0001180000001A10ull)
#define  CVMX_LED_PRT_FMT                                     CVMX_ADD_IO_SEG(0x0001180000001A30ull)
#define  CVMX_LED_PRT_STATUSX(offset)                        (CVMX_ADD_IO_SEG(0x0001180000001A80ull+((offset)*8)))
#define  CVMX_LED_UDD_CNTX(offset)                           (CVMX_ADD_IO_SEG(0x0001180000001A20ull+((offset)*8)))
#define  CVMX_LED_UDD_DATX(offset)                           (CVMX_ADD_IO_SEG(0x0001180000001A38ull+((offset)*8)))
#define  CVMX_LED_UDD_DAT_CLRX(offset)                       (CVMX_ADD_IO_SEG(0x0001180000001AC8ull+((offset)*16)))
#define  CVMX_LED_UDD_DAT_SETX(offset)                       (CVMX_ADD_IO_SEG(0x0001180000001AC0ull+((offset)*16)))
#define  CVMX_LMC_COMP_CTL                                    CVMX_ADD_IO_SEG(0x0001180088000028ull)
#define  CVMX_LMC_CTL                                         CVMX_ADD_IO_SEG(0x0001180088000010ull)
#define  CVMX_LMC_CTL1                                        CVMX_ADD_IO_SEG(0x0001180088000090ull)
#define  CVMX_LMC_DCLK_CNT_HI                                 CVMX_ADD_IO_SEG(0x0001180088000070ull)
#define  CVMX_LMC_DCLK_CNT_LO                                 CVMX_ADD_IO_SEG(0x0001180088000068ull)
#define  CVMX_LMC_DDR2_CTL                                    CVMX_ADD_IO_SEG(0x0001180088000018ull)
#define  CVMX_LMC_DELAY_CFG                                   CVMX_ADD_IO_SEG(0x0001180088000088ull)
#define  CVMX_LMC_ECC_SYND                                    CVMX_ADD_IO_SEG(0x0001180088000038ull)
#define  CVMX_LMC_FADR                                        CVMX_ADD_IO_SEG(0x0001180088000020ull)
#define  CVMX_LMC_IFB_CNT_HI                                  CVMX_ADD_IO_SEG(0x0001180088000050ull)
#define  CVMX_LMC_IFB_CNT_LO                                  CVMX_ADD_IO_SEG(0x0001180088000048ull)
#define  CVMX_LMC_MEM_CFG0                                    CVMX_ADD_IO_SEG(0x0001180088000000ull)
#define  CVMX_LMC_MEM_CFG1                                    CVMX_ADD_IO_SEG(0x0001180088000008ull)
#define  CVMX_LMC_OPS_CNT_HI                                  CVMX_ADD_IO_SEG(0x0001180088000060ull)
#define  CVMX_LMC_OPS_CNT_LO                                  CVMX_ADD_IO_SEG(0x0001180088000058ull)
#define  CVMX_LMC_PLL_BWCTL                                   CVMX_ADD_IO_SEG(0x0001180088000040ull)
#define  CVMX_LMC_RODT_COMP_CTL                               CVMX_ADD_IO_SEG(0x0001180088000090ull)
#define  CVMX_LMC_RODT_CTL                                    CVMX_ADD_IO_SEG(0x0001180088000078ull)
#define  CVMX_LMC_WODT_CTL                                    CVMX_ADD_IO_SEG(0x0001180088000030ull)
#define  CVMX_LMC_WODT_CTL0                                   CVMX_ADD_IO_SEG(0x0001180088000030ull)
#define  CVMX_LMC_WODT_CTL1                                   CVMX_ADD_IO_SEG(0x0001180088000080ull)
#define  CVMX_MIO_BOOT_BIST_STAT                              CVMX_ADD_IO_SEG(0x00011800000000F8ull)
#define  CVMX_MIO_BOOT_ERR                                    CVMX_ADD_IO_SEG(0x00011800000000A0ull)
#define  CVMX_MIO_BOOT_INT                                    CVMX_ADD_IO_SEG(0x00011800000000A8ull)
#define  CVMX_MIO_BOOT_LOC_ADR                                CVMX_ADD_IO_SEG(0x0001180000000090ull)
#define  CVMX_MIO_BOOT_LOC_CFGX(offset)                      (CVMX_ADD_IO_SEG(0x0001180000000080ull+((offset)*8)))
#define  CVMX_MIO_BOOT_LOC_DAT                                CVMX_ADD_IO_SEG(0x0001180000000098ull)
#define  CVMX_MIO_BOOT_REG_CFG0                               CVMX_ADD_IO_SEG(0x0001180000000000ull)
#define  CVMX_MIO_BOOT_REG_CFGX(offset)                      (CVMX_ADD_IO_SEG(0x0001180000000008ull+((offset)*8)-8*1))
#define  CVMX_MIO_BOOT_REG_TIM0                               CVMX_ADD_IO_SEG(0x0001180000000040ull)
#define  CVMX_MIO_BOOT_REG_TIMX(offset)                      (CVMX_ADD_IO_SEG(0x0001180000000048ull+((offset)*8)-8*1))
#define  CVMX_MIO_BOOT_THR                                    CVMX_ADD_IO_SEG(0x00011800000000B0ull)
#define  CVMX_MIO_FUS_BNK_DATX(offset)                       (CVMX_ADD_IO_SEG(0x0001180000001520ull+((offset)*8)))
#define  CVMX_MIO_FUS_DAT0                                    CVMX_ADD_IO_SEG(0x0001180000001400ull)
#define  CVMX_MIO_FUS_DAT1                                    CVMX_ADD_IO_SEG(0x0001180000001408ull)
#define  CVMX_MIO_FUS_DAT2                                    CVMX_ADD_IO_SEG(0x0001180000001410ull)
#define  CVMX_MIO_FUS_DAT3                                    CVMX_ADD_IO_SEG(0x0001180000001418ull)
#define  CVMX_MIO_FUS_PROG                                    CVMX_ADD_IO_SEG(0x0001180000001510ull)
#define  CVMX_MIO_FUS_PROG_TIMES                              CVMX_ADD_IO_SEG(0x0001180000001518ull)
#define  CVMX_MIO_FUS_RCMD                                    CVMX_ADD_IO_SEG(0x0001180000001500ull)
#define  CVMX_MIO_FUS_SPR_REPAIR_RES                          CVMX_ADD_IO_SEG(0x0001180000001548ull)
#define  CVMX_MIO_FUS_SPR_REPAIR_SUM                          CVMX_ADD_IO_SEG(0x0001180000001540ull)
#define  CVMX_MIO_FUS_UNLOCK                                  CVMX_ADD_IO_SEG(0x0001180000001578ull)
#define  CVMX_MIO_FUS_WADR                                    CVMX_ADD_IO_SEG(0x0001180000001508ull)
#define  CVMX_MIO_PLL_CTL                                     CVMX_ADD_IO_SEG(0x0001180000001448ull)
#define  CVMX_MIO_PLL_SETTING                                 CVMX_ADD_IO_SEG(0x0001180000001440ull)
#define  CVMX_MIO_TWS_INT                                     CVMX_ADD_IO_SEG(0x0001180000001010ull)
#define  CVMX_MIO_TWS_SW_TWSI                                 CVMX_ADD_IO_SEG(0x0001180000001000ull)
#define  CVMX_MIO_TWS_SW_TWSI_EXT                             CVMX_ADD_IO_SEG(0x0001180000001018ull)
#define  CVMX_MIO_TWS_TWSI_SW                                 CVMX_ADD_IO_SEG(0x0001180000001008ull)
#define  CVMX_MIO_UARTX_DLH(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000888ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_DLL(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000880ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_FAR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000920ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_FCR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000850ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_HTX(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000B08ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_IER(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000808ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_IIR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000810ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_LCR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000818ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_LSR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000828ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_MCR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000820ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_MSR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000830ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_RBR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000800ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_RFL(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000A08ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_RFW(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000930ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SBCR(offset)                         (CVMX_ADD_IO_SEG(0x0001180000000A20ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SCR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000838ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SFE(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000A30ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SRR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000A10ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SRT(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000A38ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_SRTS(offset)                         (CVMX_ADD_IO_SEG(0x0001180000000A18ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_STT(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000B00ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_TFL(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000A00ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_TFR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000928ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_THR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000840ull+((offset)*1024)))
#define  CVMX_MIO_UARTX_USR(offset)                          (CVMX_ADD_IO_SEG(0x0001180000000938ull+((offset)*1024)))
#define  CVMX_MPI_CFG                                         CVMX_ADD_IO_SEG(0x0001070000001000ull)
#define  CVMX_MPI_DATX(offset)                               (CVMX_ADD_IO_SEG(0x0001070000001080ull+((offset)*8)))
#define  CVMX_MPI_STS                                         CVMX_ADD_IO_SEG(0x0001070000001008ull)
#define  CVMX_MPI_TX                                          CVMX_ADD_IO_SEG(0x0001070000001010ull)
#define  CVMX_NPI_BASE_ADDR_INPUT0                            CVMX_ADD_IO_SEG(0x00011F0000000070ull)
#define  CVMX_NPI_BASE_ADDR_INPUT1                            CVMX_ADD_IO_SEG(0x00011F0000000080ull)
#define  CVMX_NPI_BASE_ADDR_INPUT2                            CVMX_ADD_IO_SEG(0x00011F0000000090ull)
#define  CVMX_NPI_BASE_ADDR_INPUT3                            CVMX_ADD_IO_SEG(0x00011F00000000A0ull)
#define  CVMX_NPI_BASE_ADDR_OUTPUT0                           CVMX_ADD_IO_SEG(0x00011F00000000B8ull)
#define  CVMX_NPI_BASE_ADDR_OUTPUT1                           CVMX_ADD_IO_SEG(0x00011F00000000C0ull)
#define  CVMX_NPI_BASE_ADDR_OUTPUT2                           CVMX_ADD_IO_SEG(0x00011F00000000C8ull)
#define  CVMX_NPI_BASE_ADDR_OUTPUT3                           CVMX_ADD_IO_SEG(0x00011F00000000D0ull)
#define  CVMX_NPI_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00011F00000003F8ull)
#define  CVMX_NPI_BUFF_SIZE_OUTPUT0                           CVMX_ADD_IO_SEG(0x00011F00000000E0ull)
#define  CVMX_NPI_BUFF_SIZE_OUTPUT1                           CVMX_ADD_IO_SEG(0x00011F00000000E8ull)
#define  CVMX_NPI_BUFF_SIZE_OUTPUT2                           CVMX_ADD_IO_SEG(0x00011F00000000F0ull)
#define  CVMX_NPI_BUFF_SIZE_OUTPUT3                           CVMX_ADD_IO_SEG(0x00011F00000000F8ull)
#define  CVMX_NPI_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x00011F0000000010ull)
#define  CVMX_NPI_DBG_SELECT                                  CVMX_ADD_IO_SEG(0x00011F0000000008ull)
#define  CVMX_NPI_DMA_CONTROL                                 CVMX_ADD_IO_SEG(0x00011F0000000128ull)
#define  CVMX_NPI_DMA_HIGHP_COUNTS                            CVMX_ADD_IO_SEG(0x00011F0000000148ull)
#define  CVMX_NPI_DMA_HIGHP_NADDR                             CVMX_ADD_IO_SEG(0x00011F0000000158ull)
#define  CVMX_NPI_DMA_LOWP_COUNTS                             CVMX_ADD_IO_SEG(0x00011F0000000140ull)
#define  CVMX_NPI_DMA_LOWP_NADDR                              CVMX_ADD_IO_SEG(0x00011F0000000150ull)
#define  CVMX_NPI_HIGHP_DBELL                                 CVMX_ADD_IO_SEG(0x00011F0000000120ull)
#define  CVMX_NPI_HIGHP_IBUFF_SADDR                           CVMX_ADD_IO_SEG(0x00011F0000000110ull)
#define  CVMX_NPI_INPUT_CONTROL                               CVMX_ADD_IO_SEG(0x00011F0000000138ull)
#define  CVMX_NPI_INT_ENB                                     CVMX_ADD_IO_SEG(0x00011F0000000020ull)
#define  CVMX_NPI_INT_SUM                                     CVMX_ADD_IO_SEG(0x00011F0000000018ull)
#define  CVMX_NPI_LOWP_DBELL                                  CVMX_ADD_IO_SEG(0x00011F0000000118ull)
#define  CVMX_NPI_LOWP_IBUFF_SADDR                            CVMX_ADD_IO_SEG(0x00011F0000000108ull)
#define  CVMX_NPI_MEM_ACCESS_SUBID3                           CVMX_ADD_IO_SEG(0x00011F0000000028ull)
#define  CVMX_NPI_MEM_ACCESS_SUBID4                           CVMX_ADD_IO_SEG(0x00011F0000000030ull)
#define  CVMX_NPI_MEM_ACCESS_SUBID5                           CVMX_ADD_IO_SEG(0x00011F0000000038ull)
#define  CVMX_NPI_MEM_ACCESS_SUBID6                           CVMX_ADD_IO_SEG(0x00011F0000000040ull)
#define  CVMX_NPI_MSI_RCV                                                    (0x0000000000000190ull)
#define  CVMX_NPI_NPI_MSI_RCV                                 CVMX_ADD_IO_SEG(0x00011F0000001190ull)
#define  CVMX_NPI_NUM_DESC_OUTPUT0                            CVMX_ADD_IO_SEG(0x00011F0000000050ull)
#define  CVMX_NPI_NUM_DESC_OUTPUT1                            CVMX_ADD_IO_SEG(0x00011F0000000058ull)
#define  CVMX_NPI_NUM_DESC_OUTPUT2                            CVMX_ADD_IO_SEG(0x00011F0000000060ull)
#define  CVMX_NPI_NUM_DESC_OUTPUT3                            CVMX_ADD_IO_SEG(0x00011F0000000068ull)
#define  CVMX_NPI_OUTPUT_CONTROL                              CVMX_ADD_IO_SEG(0x00011F0000000100ull)
#define  CVMX_NPI_P0_DBPAIR_ADDR                              CVMX_ADD_IO_SEG(0x00011F0000000180ull)
#define  CVMX_NPI_P0_INSTR_ADDR                               CVMX_ADD_IO_SEG(0x00011F00000001C0ull)
#define  CVMX_NPI_P0_INSTR_CNTS                               CVMX_ADD_IO_SEG(0x00011F00000001A0ull)
#define  CVMX_NPI_P0_PAIR_CNTS                                CVMX_ADD_IO_SEG(0x00011F0000000160ull)
#define  CVMX_NPI_P1_DBPAIR_ADDR                              CVMX_ADD_IO_SEG(0x00011F0000000188ull)
#define  CVMX_NPI_P1_INSTR_ADDR                               CVMX_ADD_IO_SEG(0x00011F00000001C8ull)
#define  CVMX_NPI_P1_INSTR_CNTS                               CVMX_ADD_IO_SEG(0x00011F00000001A8ull)
#define  CVMX_NPI_P1_PAIR_CNTS                                CVMX_ADD_IO_SEG(0x00011F0000000168ull)
#define  CVMX_NPI_P2_DBPAIR_ADDR                              CVMX_ADD_IO_SEG(0x00011F0000000190ull)
#define  CVMX_NPI_P2_INSTR_ADDR                               CVMX_ADD_IO_SEG(0x00011F00000001D0ull)
#define  CVMX_NPI_P2_INSTR_CNTS                               CVMX_ADD_IO_SEG(0x00011F00000001B0ull)
#define  CVMX_NPI_P2_PAIR_CNTS                                CVMX_ADD_IO_SEG(0x00011F0000000170ull)
#define  CVMX_NPI_P3_DBPAIR_ADDR                              CVMX_ADD_IO_SEG(0x00011F0000000198ull)
#define  CVMX_NPI_P3_INSTR_ADDR                               CVMX_ADD_IO_SEG(0x00011F00000001D8ull)
#define  CVMX_NPI_P3_INSTR_CNTS                               CVMX_ADD_IO_SEG(0x00011F00000001B8ull)
#define  CVMX_NPI_P3_PAIR_CNTS                                CVMX_ADD_IO_SEG(0x00011F0000000178ull)
#define  CVMX_NPI_PCI_BAR1_INDEXX(offset)                    (CVMX_ADD_IO_SEG(0x00011F0000001100ull+((offset)*4)))
#define  CVMX_NPI_PCI_BURST_SIZE                              CVMX_ADD_IO_SEG(0x00011F00000000D8ull)
#define  CVMX_NPI_PCI_CFG00                                   CVMX_ADD_IO_SEG(0x00011F0000001800ull)
#define  CVMX_NPI_PCI_CFG01                                   CVMX_ADD_IO_SEG(0x00011F0000001804ull)
#define  CVMX_NPI_PCI_CFG02                                   CVMX_ADD_IO_SEG(0x00011F0000001808ull)
#define  CVMX_NPI_PCI_CFG03                                   CVMX_ADD_IO_SEG(0x00011F000000180Cull)
#define  CVMX_NPI_PCI_CFG04                                   CVMX_ADD_IO_SEG(0x00011F0000001810ull)
#define  CVMX_NPI_PCI_CFG05                                   CVMX_ADD_IO_SEG(0x00011F0000001814ull)
#define  CVMX_NPI_PCI_CFG06                                   CVMX_ADD_IO_SEG(0x00011F0000001818ull)
#define  CVMX_NPI_PCI_CFG07                                   CVMX_ADD_IO_SEG(0x00011F000000181Cull)
#define  CVMX_NPI_PCI_CFG08                                   CVMX_ADD_IO_SEG(0x00011F0000001820ull)
#define  CVMX_NPI_PCI_CFG09                                   CVMX_ADD_IO_SEG(0x00011F0000001824ull)
#define  CVMX_NPI_PCI_CFG10                                   CVMX_ADD_IO_SEG(0x00011F0000001828ull)
#define  CVMX_NPI_PCI_CFG11                                   CVMX_ADD_IO_SEG(0x00011F000000182Cull)
#define  CVMX_NPI_PCI_CFG12                                   CVMX_ADD_IO_SEG(0x00011F0000001830ull)
#define  CVMX_NPI_PCI_CFG13                                   CVMX_ADD_IO_SEG(0x00011F0000001834ull)
#define  CVMX_NPI_PCI_CFG15                                   CVMX_ADD_IO_SEG(0x00011F000000183Cull)
#define  CVMX_NPI_PCI_CFG16                                   CVMX_ADD_IO_SEG(0x00011F0000001840ull)
#define  CVMX_NPI_PCI_CFG17                                   CVMX_ADD_IO_SEG(0x00011F0000001844ull)
#define  CVMX_NPI_PCI_CFG18                                   CVMX_ADD_IO_SEG(0x00011F0000001848ull)
#define  CVMX_NPI_PCI_CFG19                                   CVMX_ADD_IO_SEG(0x00011F000000184Cull)
#define  CVMX_NPI_PCI_CFG20                                   CVMX_ADD_IO_SEG(0x00011F0000001850ull)
#define  CVMX_NPI_PCI_CFG21                                   CVMX_ADD_IO_SEG(0x00011F0000001854ull)
#define  CVMX_NPI_PCI_CFG22                                   CVMX_ADD_IO_SEG(0x00011F0000001858ull)
#define  CVMX_NPI_PCI_CFG56                                   CVMX_ADD_IO_SEG(0x00011F00000018E0ull)
#define  CVMX_NPI_PCI_CFG57                                   CVMX_ADD_IO_SEG(0x00011F00000018E4ull)
#define  CVMX_NPI_PCI_CFG58                                   CVMX_ADD_IO_SEG(0x00011F00000018E8ull)
#define  CVMX_NPI_PCI_CFG59                                   CVMX_ADD_IO_SEG(0x00011F00000018ECull)
#define  CVMX_NPI_PCI_CFG60                                   CVMX_ADD_IO_SEG(0x00011F00000018F0ull)
#define  CVMX_NPI_PCI_CFG61                                   CVMX_ADD_IO_SEG(0x00011F00000018F4ull)
#define  CVMX_NPI_PCI_CFG62                                   CVMX_ADD_IO_SEG(0x00011F00000018F8ull)
#define  CVMX_NPI_PCI_CFG63                                   CVMX_ADD_IO_SEG(0x00011F00000018FCull)
#define  CVMX_NPI_PCI_CTL_STATUS_2                            CVMX_ADD_IO_SEG(0x00011F000000118Cull)
#define  CVMX_NPI_PCI_INT_ARB_CFG                             CVMX_ADD_IO_SEG(0x00011F0000000130ull)
#define  CVMX_NPI_PCI_INT_ENB2                                CVMX_ADD_IO_SEG(0x00011F00000011A0ull)
#define  CVMX_NPI_PCI_INT_SUM2                                CVMX_ADD_IO_SEG(0x00011F0000001198ull)
#define  CVMX_NPI_PCI_READ_CMD                                CVMX_ADD_IO_SEG(0x00011F0000000048ull)
#define  CVMX_NPI_PCI_READ_CMD_6                              CVMX_ADD_IO_SEG(0x00011F0000001180ull)
#define  CVMX_NPI_PCI_READ_CMD_C                              CVMX_ADD_IO_SEG(0x00011F0000001184ull)
#define  CVMX_NPI_PCI_READ_CMD_E                              CVMX_ADD_IO_SEG(0x00011F0000001188ull)
#define  CVMX_NPI_PCI_SCM_REG                                 CVMX_ADD_IO_SEG(0x00011F00000011A8ull)
#define  CVMX_NPI_PCI_TSR_REG                                 CVMX_ADD_IO_SEG(0x00011F00000011B0ull)
#define  CVMX_NPI_PORT32_INSTR_HDR                            CVMX_ADD_IO_SEG(0x00011F00000001F8ull)
#define  CVMX_NPI_PORT33_INSTR_HDR                            CVMX_ADD_IO_SEG(0x00011F0000000200ull)
#define  CVMX_NPI_PORT34_INSTR_HDR                            CVMX_ADD_IO_SEG(0x00011F0000000208ull)
#define  CVMX_NPI_PORT35_INSTR_HDR                            CVMX_ADD_IO_SEG(0x00011F0000000210ull)
#define  CVMX_NPI_PORT_BP_CONTROL                             CVMX_ADD_IO_SEG(0x00011F00000001F0ull)
#define  CVMX_NPI_RSL_INT_BLOCKS                              CVMX_ADD_IO_SEG(0x00011F0000000000ull)
#define  CVMX_NPI_SIZE_INPUT0                                 CVMX_ADD_IO_SEG(0x00011F0000000078ull)
#define  CVMX_NPI_SIZE_INPUT1                                 CVMX_ADD_IO_SEG(0x00011F0000000088ull)
#define  CVMX_NPI_SIZE_INPUT2                                 CVMX_ADD_IO_SEG(0x00011F0000000098ull)
#define  CVMX_NPI_SIZE_INPUT3                                 CVMX_ADD_IO_SEG(0x00011F00000000A8ull)
#define  CVMX_NPI_WIN_READ_TO                                 CVMX_ADD_IO_SEG(0x00011F00000001E0ull)
#define  CVMX_PCI_BAR1_INDEXX(offset)                                       ((0x0000000000000100ull+((offset)*4)))
#define  CVMX_PCI_CFG00                                                      (0x0000000000000000ull)
#define  CVMX_PCI_CFG01                                                      (0x0000000000000004ull)
#define  CVMX_PCI_CFG02                                                      (0x0000000000000008ull)
#define  CVMX_PCI_CFG03                                                      (0x000000000000000Cull)
#define  CVMX_PCI_CFG04                                                      (0x0000000000000010ull)
#define  CVMX_PCI_CFG05                                                      (0x0000000000000014ull)
#define  CVMX_PCI_CFG06                                                      (0x0000000000000018ull)
#define  CVMX_PCI_CFG07                                                      (0x000000000000001Cull)
#define  CVMX_PCI_CFG08                                                      (0x0000000000000020ull)
#define  CVMX_PCI_CFG09                                                      (0x0000000000000024ull)
#define  CVMX_PCI_CFG10                                                      (0x0000000000000028ull)
#define  CVMX_PCI_CFG11                                                      (0x000000000000002Cull)
#define  CVMX_PCI_CFG12                                                      (0x0000000000000030ull)
#define  CVMX_PCI_CFG13                                                      (0x0000000000000034ull)
#define  CVMX_PCI_CFG15                                                      (0x000000000000003Cull)
#define  CVMX_PCI_CFG16                                                      (0x0000000000000040ull)
#define  CVMX_PCI_CFG17                                                      (0x0000000000000044ull)
#define  CVMX_PCI_CFG18                                                      (0x0000000000000048ull)
#define  CVMX_PCI_CFG19                                                      (0x000000000000004Cull)
#define  CVMX_PCI_CFG20                                                      (0x0000000000000050ull)
#define  CVMX_PCI_CFG21                                                      (0x0000000000000054ull)
#define  CVMX_PCI_CFG22                                                      (0x0000000000000058ull)
#define  CVMX_PCI_CFG56                                                      (0x00000000000000E0ull)
#define  CVMX_PCI_CFG57                                                      (0x00000000000000E4ull)
#define  CVMX_PCI_CFG58                                                      (0x00000000000000E8ull)
#define  CVMX_PCI_CFG59                                                      (0x00000000000000ECull)
#define  CVMX_PCI_CFG60                                                      (0x00000000000000F0ull)
#define  CVMX_PCI_CFG61                                                      (0x00000000000000F4ull)
#define  CVMX_PCI_CFG62                                                      (0x00000000000000F8ull)
#define  CVMX_PCI_CFG63                                                      (0x00000000000000FCull)
#define  CVMX_PCI_CNT_REG                                                    (0x00000000000001B8ull)
#define  CVMX_PCI_CTL_STATUS_2                                               (0x000000000000018Cull)
#define  CVMX_PCI_DBELL_0                                                    (0x0000000000000080ull)
#define  CVMX_PCI_DBELL_1                                                    (0x0000000000000088ull)
#define  CVMX_PCI_DBELL_2                                                    (0x0000000000000090ull)
#define  CVMX_PCI_DBELL_3                                                    (0x0000000000000098ull)
#define  CVMX_PCI_DMA_CNT0                                                   (0x00000000000000A0ull)
#define  CVMX_PCI_DMA_CNT1                                                   (0x00000000000000A8ull)
#define  CVMX_PCI_DMA_INT_LEV0                                               (0x00000000000000A4ull)
#define  CVMX_PCI_DMA_INT_LEV1                                               (0x00000000000000ACull)
#define  CVMX_PCI_DMA_TIME0                                                  (0x00000000000000B0ull)
#define  CVMX_PCI_DMA_TIME1                                                  (0x00000000000000B4ull)
#define  CVMX_PCI_INSTR_COUNT0                                               (0x0000000000000084ull)
#define  CVMX_PCI_INSTR_COUNT1                                               (0x000000000000008Cull)
#define  CVMX_PCI_INSTR_COUNT2                                               (0x0000000000000094ull)
#define  CVMX_PCI_INSTR_COUNT3                                               (0x000000000000009Cull)
#define  CVMX_PCI_INT_ENB                                                    (0x0000000000000038ull)
#define  CVMX_PCI_INT_ENB2                                                   (0x00000000000001A0ull)
#define  CVMX_PCI_INT_SUM                                                    (0x0000000000000030ull)
#define  CVMX_PCI_INT_SUM2                                                   (0x0000000000000198ull)
#define  CVMX_PCI_MSI_RCV                                                    (0x00000000000000F0ull)
#define  CVMX_PCI_PKTS_SENT0                                                 (0x0000000000000040ull)
#define  CVMX_PCI_PKTS_SENT1                                                 (0x0000000000000050ull)
#define  CVMX_PCI_PKTS_SENT2                                                 (0x0000000000000060ull)
#define  CVMX_PCI_PKTS_SENT3                                                 (0x0000000000000070ull)
#define  CVMX_PCI_PKTS_SENT_INT_LEV0                                         (0x0000000000000048ull)
#define  CVMX_PCI_PKTS_SENT_INT_LEV1                                         (0x0000000000000058ull)
#define  CVMX_PCI_PKTS_SENT_INT_LEV2                                         (0x0000000000000068ull)
#define  CVMX_PCI_PKTS_SENT_INT_LEV3                                         (0x0000000000000078ull)
#define  CVMX_PCI_PKTS_SENT_TIME0                                            (0x000000000000004Cull)
#define  CVMX_PCI_PKTS_SENT_TIME1                                            (0x000000000000005Cull)
#define  CVMX_PCI_PKTS_SENT_TIME2                                            (0x000000000000006Cull)
#define  CVMX_PCI_PKTS_SENT_TIME3                                            (0x000000000000007Cull)
#define  CVMX_PCI_PKT_CREDITS0                                               (0x0000000000000044ull)
#define  CVMX_PCI_PKT_CREDITS1                                               (0x0000000000000054ull)
#define  CVMX_PCI_PKT_CREDITS2                                               (0x0000000000000064ull)
#define  CVMX_PCI_PKT_CREDITS3                                               (0x0000000000000074ull)
#define  CVMX_PCI_READ_CMD_6                                                 (0x0000000000000180ull)
#define  CVMX_PCI_READ_CMD_C                                                 (0x0000000000000184ull)
#define  CVMX_PCI_READ_CMD_E                                                 (0x0000000000000188ull)
#define  CVMX_PCI_READ_TIMEOUT                                CVMX_ADD_IO_SEG(0x00011F00000000B0ull)
#define  CVMX_PCI_SCM_REG                                                    (0x00000000000001A8ull)
#define  CVMX_PCI_TSR_REG                                                    (0x00000000000001B0ull)
#define  CVMX_PCI_WIN_RD_ADDR                                                (0x0000000000000008ull)
#define  CVMX_PCI_WIN_RD_DATA                                                (0x0000000000000020ull)
#define  CVMX_PCI_WIN_WR_ADDR                                                (0x0000000000000000ull)
#define  CVMX_PCI_WIN_WR_DATA                                                (0x0000000000000010ull)
#define  CVMX_PCI_WIN_WR_MASK                                                (0x0000000000000018ull)
#define  CVMX_PCMX_DMA_CFG(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010018ull+((offset)*16384)))
#define  CVMX_PCMX_INT_ENA(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010020ull+((offset)*16384)))
#define  CVMX_PCMX_INT_SUM(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010028ull+((offset)*16384)))
#define  CVMX_PCMX_RXADDR(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010068ull+((offset)*16384)))
#define  CVMX_PCMX_RXCNT(offset)                             (CVMX_ADD_IO_SEG(0x0001070000010060ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK0(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100C0ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK1(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100C8ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK2(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100D0ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK3(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100D8ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK4(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100E0ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK5(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100E8ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK6(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100F0ull+((offset)*16384)))
#define  CVMX_PCMX_RXMSK7(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100F8ull+((offset)*16384)))
#define  CVMX_PCMX_RXSTART(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010058ull+((offset)*16384)))
#define  CVMX_PCMX_TDM_CFG(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010010ull+((offset)*16384)))
#define  CVMX_PCMX_TDM_DBG(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010030ull+((offset)*16384)))
#define  CVMX_PCMX_TXADDR(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010050ull+((offset)*16384)))
#define  CVMX_PCMX_TXCNT(offset)                             (CVMX_ADD_IO_SEG(0x0001070000010048ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK0(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010080ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK1(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010088ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK2(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010090ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK3(offset)                            (CVMX_ADD_IO_SEG(0x0001070000010098ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK4(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100A0ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK5(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100A8ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK6(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100B0ull+((offset)*16384)))
#define  CVMX_PCMX_TXMSK7(offset)                            (CVMX_ADD_IO_SEG(0x00010700000100B8ull+((offset)*16384)))
#define  CVMX_PCMX_TXSTART(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010040ull+((offset)*16384)))
#define  CVMX_PCM_CLKX_CFG(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010000ull+((offset)*16384)))
#define  CVMX_PCM_CLKX_DBG(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010038ull+((offset)*16384)))
#define  CVMX_PCM_CLKX_GEN(offset)                           (CVMX_ADD_IO_SEG(0x0001070000010008ull+((offset)*16384)))
#define  CVMX_PIP_BCK_PRS                                     CVMX_ADD_IO_SEG(0x00011800A0000038ull)
#define  CVMX_PIP_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00011800A0000000ull)
#define  CVMX_PIP_CRC_CTLX(offset)                           (CVMX_ADD_IO_SEG(0x00011800A0000040ull+((offset)*8)))
#define  CVMX_PIP_CRC_IVX(offset)                            (CVMX_ADD_IO_SEG(0x00011800A0000050ull+((offset)*8)))
#define  CVMX_PIP_DEC_IPSECX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000080ull+((offset)*8)))
#define  CVMX_PIP_GBL_CFG                                     CVMX_ADD_IO_SEG(0x00011800A0000028ull)
#define  CVMX_PIP_GBL_CTL                                     CVMX_ADD_IO_SEG(0x00011800A0000020ull)
#define  CVMX_PIP_INT_EN                                      CVMX_ADD_IO_SEG(0x00011800A0000010ull)
#define  CVMX_PIP_INT_REG                                     CVMX_ADD_IO_SEG(0x00011800A0000008ull)
#define  CVMX_PIP_IP_OFFSET                                   CVMX_ADD_IO_SEG(0x00011800A0000060ull)
#define  CVMX_PIP_PRT_CFGX(offset)                           (CVMX_ADD_IO_SEG(0x00011800A0000200ull+((offset)*8)))
#define  CVMX_PIP_PRT_TAGX(offset)                           (CVMX_ADD_IO_SEG(0x00011800A0000400ull+((offset)*8)))
#define  CVMX_PIP_QOS_DIFFX(offset)                          (CVMX_ADD_IO_SEG(0x00011800A0000600ull+((offset)*8)))
#define  CVMX_PIP_QOS_VLANX(offset)                          (CVMX_ADD_IO_SEG(0x00011800A00000C0ull+((offset)*8)))
#define  CVMX_PIP_QOS_WATCHX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000100ull+((offset)*8)))
#define  CVMX_PIP_RAW_WORD                                    CVMX_ADD_IO_SEG(0x00011800A00000B0ull)
#define  CVMX_PIP_SFT_RST                                     CVMX_ADD_IO_SEG(0x00011800A0000030ull)
#define  CVMX_PIP_STAT0_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000800ull+((offset)*80)))
#define  CVMX_PIP_STAT1_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000808ull+((offset)*80)))
#define  CVMX_PIP_STAT2_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000810ull+((offset)*80)))
#define  CVMX_PIP_STAT3_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000818ull+((offset)*80)))
#define  CVMX_PIP_STAT4_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000820ull+((offset)*80)))
#define  CVMX_PIP_STAT5_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000828ull+((offset)*80)))
#define  CVMX_PIP_STAT6_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000830ull+((offset)*80)))
#define  CVMX_PIP_STAT7_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000838ull+((offset)*80)))
#define  CVMX_PIP_STAT8_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000840ull+((offset)*80)))
#define  CVMX_PIP_STAT9_PRTX(offset)                         (CVMX_ADD_IO_SEG(0x00011800A0000848ull+((offset)*80)))
#define  CVMX_PIP_STAT_CTL                                    CVMX_ADD_IO_SEG(0x00011800A0000018ull)
#define  CVMX_PIP_STAT_INB_ERRSX(offset)                     (CVMX_ADD_IO_SEG(0x00011800A0001A10ull+((offset)*32)))
#define  CVMX_PIP_STAT_INB_OCTSX(offset)                     (CVMX_ADD_IO_SEG(0x00011800A0001A08ull+((offset)*32)))
#define  CVMX_PIP_STAT_INB_PKTSX(offset)                     (CVMX_ADD_IO_SEG(0x00011800A0001A00ull+((offset)*32)))
#define  CVMX_PIP_TAG_INCX(offset)                           (CVMX_ADD_IO_SEG(0x00011800A0001800ull+((offset)*8)))
#define  CVMX_PIP_TAG_MASK                                    CVMX_ADD_IO_SEG(0x00011800A0000070ull)
#define  CVMX_PIP_TAG_SECRET                                  CVMX_ADD_IO_SEG(0x00011800A0000068ull)
#define  CVMX_PIP_TODO_ENTRY                                  CVMX_ADD_IO_SEG(0x00011800A0000078ull)
#define  CVMX_PKO_MEM_COUNT0                                  CVMX_ADD_IO_SEG(0x0001180050001080ull)
#define  CVMX_PKO_MEM_COUNT1                                  CVMX_ADD_IO_SEG(0x0001180050001088ull)
#define  CVMX_PKO_MEM_DEBUG0                                  CVMX_ADD_IO_SEG(0x0001180050001100ull)
#define  CVMX_PKO_MEM_DEBUG1                                  CVMX_ADD_IO_SEG(0x0001180050001108ull)
#define  CVMX_PKO_MEM_DEBUG10                                 CVMX_ADD_IO_SEG(0x0001180050001150ull)
#define  CVMX_PKO_MEM_DEBUG11                                 CVMX_ADD_IO_SEG(0x0001180050001158ull)
#define  CVMX_PKO_MEM_DEBUG12                                 CVMX_ADD_IO_SEG(0x0001180050001160ull)
#define  CVMX_PKO_MEM_DEBUG13                                 CVMX_ADD_IO_SEG(0x0001180050001168ull)
#define  CVMX_PKO_MEM_DEBUG14                                 CVMX_ADD_IO_SEG(0x0001180050001170ull)
#define  CVMX_PKO_MEM_DEBUG2                                  CVMX_ADD_IO_SEG(0x0001180050001110ull)
#define  CVMX_PKO_MEM_DEBUG3                                  CVMX_ADD_IO_SEG(0x0001180050001118ull)
#define  CVMX_PKO_MEM_DEBUG4                                  CVMX_ADD_IO_SEG(0x0001180050001120ull)
#define  CVMX_PKO_MEM_DEBUG5                                  CVMX_ADD_IO_SEG(0x0001180050001128ull)
#define  CVMX_PKO_MEM_DEBUG6                                  CVMX_ADD_IO_SEG(0x0001180050001130ull)
#define  CVMX_PKO_MEM_DEBUG7                                  CVMX_ADD_IO_SEG(0x0001180050001138ull)
#define  CVMX_PKO_MEM_DEBUG8                                  CVMX_ADD_IO_SEG(0x0001180050001140ull)
#define  CVMX_PKO_MEM_DEBUG9                                  CVMX_ADD_IO_SEG(0x0001180050001148ull)
#define  CVMX_PKO_MEM_QUEUE_PTRS                              CVMX_ADD_IO_SEG(0x0001180050001000ull)
#define  CVMX_PKO_MEM_QUEUE_QOS                               CVMX_ADD_IO_SEG(0x0001180050001008ull)
#define  CVMX_PKO_REG_BIST_RESULT                             CVMX_ADD_IO_SEG(0x0001180050000080ull)
#define  CVMX_PKO_REG_CMD_BUF                                 CVMX_ADD_IO_SEG(0x0001180050000010ull)
#define  CVMX_PKO_REG_CRC_CTLX(offset)                       (CVMX_ADD_IO_SEG(0x0001180050000028ull+((offset)*8)))
#define  CVMX_PKO_REG_CRC_ENABLE                              CVMX_ADD_IO_SEG(0x0001180050000020ull)
#define  CVMX_PKO_REG_CRC_IVX(offset)                        (CVMX_ADD_IO_SEG(0x0001180050000038ull+((offset)*8)))
#define  CVMX_PKO_REG_DEBUG0                                  CVMX_ADD_IO_SEG(0x0001180050000098ull)
#define  CVMX_PKO_REG_DEBUG1                                  CVMX_ADD_IO_SEG(0x00011800500000A0ull)
#define  CVMX_PKO_REG_DEBUG2                                  CVMX_ADD_IO_SEG(0x00011800500000A8ull)
#define  CVMX_PKO_REG_DEBUG3                                  CVMX_ADD_IO_SEG(0x00011800500000B0ull)
#define  CVMX_PKO_REG_ERROR                                   CVMX_ADD_IO_SEG(0x0001180050000088ull)
#define  CVMX_PKO_REG_FLAGS                                   CVMX_ADD_IO_SEG(0x0001180050000000ull)
#define  CVMX_PKO_REG_GMX_PORT_MODE                           CVMX_ADD_IO_SEG(0x0001180050000018ull)
#define  CVMX_PKO_REG_INT_MASK                                CVMX_ADD_IO_SEG(0x0001180050000090ull)
#define  CVMX_PKO_REG_QUEUE_MODE                              CVMX_ADD_IO_SEG(0x0001180050000048ull)
#define  CVMX_PKO_REG_QUEUE_PTRS1                             CVMX_ADD_IO_SEG(0x0001180050000100ull)
#define  CVMX_PKO_REG_READ_IDX                                CVMX_ADD_IO_SEG(0x0001180050000008ull)
#define  CVMX_POW_BIST_STAT                                   CVMX_ADD_IO_SEG(0x00016700000003F8ull)
#define  CVMX_POW_DS_PC                                       CVMX_ADD_IO_SEG(0x0001670000000398ull)
#define  CVMX_POW_ECC_ERR                                     CVMX_ADD_IO_SEG(0x0001670000000218ull)
#define  CVMX_POW_INT_CTL                                     CVMX_ADD_IO_SEG(0x0001670000000220ull)
#define  CVMX_POW_IQ_CNTX(offset)                            (CVMX_ADD_IO_SEG(0x0001670000000340ull+((offset)*8)))
#define  CVMX_POW_IQ_COM_CNT                                  CVMX_ADD_IO_SEG(0x0001670000000388ull)
#define  CVMX_POW_NOS_CNT                                     CVMX_ADD_IO_SEG(0x0001670000000228ull)
#define  CVMX_POW_NW_TIM                                      CVMX_ADD_IO_SEG(0x0001670000000210ull)
#define  CVMX_POW_PF_RST_MSK                                  CVMX_ADD_IO_SEG(0x0001670000000230ull)
#define  CVMX_POW_PP_GRP_MSKX(offset)                        (CVMX_ADD_IO_SEG(0x0001670000000000ull+((offset)*8)))
#define  CVMX_POW_QOS_RNDX(offset)                           (CVMX_ADD_IO_SEG(0x00016700000001C0ull+((offset)*8)))
#define  CVMX_POW_QOS_THRX(offset)                           (CVMX_ADD_IO_SEG(0x0001670000000180ull+((offset)*8)))
#define  CVMX_POW_TS_PC                                       CVMX_ADD_IO_SEG(0x0001670000000390ull)
#define  CVMX_POW_WA_COM_PC                                   CVMX_ADD_IO_SEG(0x0001670000000380ull)
#define  CVMX_POW_WA_PCX(offset)                             (CVMX_ADD_IO_SEG(0x0001670000000300ull+((offset)*8)))
#define  CVMX_POW_WQ_INT                                      CVMX_ADD_IO_SEG(0x0001670000000200ull)
#define  CVMX_POW_WQ_INT_CNTX(offset)                        (CVMX_ADD_IO_SEG(0x0001670000000100ull+((offset)*8)))
#define  CVMX_POW_WQ_INT_PC                                   CVMX_ADD_IO_SEG(0x0001670000000208ull)
#define  CVMX_POW_WQ_INT_THRX(offset)                        (CVMX_ADD_IO_SEG(0x0001670000000080ull+((offset)*8)))
#define  CVMX_POW_WS_PCX(offset)                             (CVMX_ADD_IO_SEG(0x0001670000000280ull+((offset)*8)))
#define  CVMX_RNM_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x0001180040000008ull)
#define  CVMX_RNM_CTL_STATUS                                  CVMX_ADD_IO_SEG(0x0001180040000000ull)
#define  CVMX_SMI_CLK                                         CVMX_ADD_IO_SEG(0x0001180000001818ull)
#define  CVMX_SMI_CMD                                         CVMX_ADD_IO_SEG(0x0001180000001800ull)
#define  CVMX_SMI_EN                                          CVMX_ADD_IO_SEG(0x0001180000001820ull)
#define  CVMX_SMI_RD_DAT                                      CVMX_ADD_IO_SEG(0x0001180000001810ull)
#define  CVMX_SMI_WR_DAT                                      CVMX_ADD_IO_SEG(0x0001180000001808ull)
#define  CVMX_SPX0_PLL_BW_CTL                                 CVMX_ADD_IO_SEG(0x0001180090000388ull)
#define  CVMX_SPX0_PLL_SETTING                                CVMX_ADD_IO_SEG(0x0001180090000380ull)
#define  CVMX_SPXX_BCKPRS_CNT(block_id)                      (CVMX_ADD_IO_SEG(0x0001180090000340ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_BIST_STAT(block_id)                       (CVMX_ADD_IO_SEG(0x00011800900007F8ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_CLK_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000348ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_CLK_STAT(block_id)                        (CVMX_ADD_IO_SEG(0x0001180090000350ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_DBG_DESKEW_CTL(block_id)                  (CVMX_ADD_IO_SEG(0x0001180090000368ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_DBG_DESKEW_STATE(block_id)                (CVMX_ADD_IO_SEG(0x0001180090000370ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_DRV_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000358ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_ERR_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000320ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_INT_DAT(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000318ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_INT_MSK(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000308ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_INT_REG(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000300ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_INT_SYNC(block_id)                        (CVMX_ADD_IO_SEG(0x0001180090000310ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_TPA_ACC(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000338ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_TPA_MAX(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000330ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_TPA_SEL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000328ull+((block_id)*0x8000000ull)))
#define  CVMX_SPXX_TRN4_CTL(block_id)                        (CVMX_ADD_IO_SEG(0x0001180090000360ull+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_COM_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000200ull+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_IGN_RX_FULL(block_id)                     (CVMX_ADD_IO_SEG(0x0001180090000218ull+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_SPI4_CALX(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180090000000ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_SPI4_STAT(block_id)                       (CVMX_ADD_IO_SEG(0x0001180090000208ull+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_SW_TICK_CTL(block_id)                     (CVMX_ADD_IO_SEG(0x0001180090000220ull+((block_id)*0x8000000ull)))
#define  CVMX_SRXX_SW_TICK_DAT(block_id)                     (CVMX_ADD_IO_SEG(0x0001180090000228ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_ARB_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000608ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_BCKPRS_CNT(block_id)                      (CVMX_ADD_IO_SEG(0x0001180090000688ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_COM_CTL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000600ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_DIP_CNT(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000690ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_IGN_CAL(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000610ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_INT_MSK(block_id)                         (CVMX_ADD_IO_SEG(0x00011800900006A0ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_INT_REG(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000698ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_INT_SYNC(block_id)                        (CVMX_ADD_IO_SEG(0x00011800900006A8ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_MIN_BST(block_id)                         (CVMX_ADD_IO_SEG(0x0001180090000618ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_SPI4_CALX(offset,block_id)                (CVMX_ADD_IO_SEG(0x0001180090000400ull+((offset)*8)+((block_id)*0x8000000ull)))
#define  CVMX_STXX_SPI4_DAT(block_id)                        (CVMX_ADD_IO_SEG(0x0001180090000628ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_SPI4_STAT(block_id)                       (CVMX_ADD_IO_SEG(0x0001180090000630ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_STAT_BYTES_HI(block_id)                   (CVMX_ADD_IO_SEG(0x0001180090000648ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_STAT_BYTES_LO(block_id)                   (CVMX_ADD_IO_SEG(0x0001180090000680ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_STAT_CTL(block_id)                        (CVMX_ADD_IO_SEG(0x0001180090000638ull+((block_id)*0x8000000ull)))
#define  CVMX_STXX_STAT_PKT_XMT(block_id)                    (CVMX_ADD_IO_SEG(0x0001180090000640ull+((block_id)*0x8000000ull)))
#define  CVMX_TIM_MEM_DEBUG0                                  CVMX_ADD_IO_SEG(0x0001180058001100ull)
#define  CVMX_TIM_MEM_DEBUG1                                  CVMX_ADD_IO_SEG(0x0001180058001108ull)
#define  CVMX_TIM_MEM_DEBUG2                                  CVMX_ADD_IO_SEG(0x0001180058001110ull)
#define  CVMX_TIM_MEM_RING0                                   CVMX_ADD_IO_SEG(0x0001180058001000ull)
#define  CVMX_TIM_MEM_RING1                                   CVMX_ADD_IO_SEG(0x0001180058001008ull)
#define  CVMX_TIM_REG_BIST_RESULT                             CVMX_ADD_IO_SEG(0x0001180058000080ull)
#define  CVMX_TIM_REG_ERROR                                   CVMX_ADD_IO_SEG(0x0001180058000088ull)
#define  CVMX_TIM_REG_FLAGS                                   CVMX_ADD_IO_SEG(0x0001180058000000ull)
#define  CVMX_TIM_REG_INT_MASK                                CVMX_ADD_IO_SEG(0x0001180058000090ull)
#define  CVMX_TIM_REG_READ_IDX                                CVMX_ADD_IO_SEG(0x0001180058000008ull)
#define  CVMX_TRA_BIST_STATUS                                 CVMX_ADD_IO_SEG(0x00011800A8000010ull)
#define  CVMX_TRA_CTL                                         CVMX_ADD_IO_SEG(0x00011800A8000000ull)
#define  CVMX_TRA_CYCLES_SINCE                                CVMX_ADD_IO_SEG(0x00011800A8000018ull)
#define  CVMX_TRA_CYCLES_SINCE1                               CVMX_ADD_IO_SEG(0x00011800A8000028ull)
#define  CVMX_TRA_FILT_ADR_ADR                                CVMX_ADD_IO_SEG(0x00011800A8000058ull)
#define  CVMX_TRA_FILT_ADR_MSK                                CVMX_ADD_IO_SEG(0x00011800A8000060ull)
#define  CVMX_TRA_FILT_CMD                                    CVMX_ADD_IO_SEG(0x00011800A8000040ull)
#define  CVMX_TRA_FILT_DID                                    CVMX_ADD_IO_SEG(0x00011800A8000050ull)
#define  CVMX_TRA_FILT_SID                                    CVMX_ADD_IO_SEG(0x00011800A8000048ull)
#define  CVMX_TRA_INT_STATUS                                  CVMX_ADD_IO_SEG(0x00011800A8000008ull)
#define  CVMX_TRA_READ_DAT                                    CVMX_ADD_IO_SEG(0x00011800A8000020ull)
#define  CVMX_TRA_TRIG0_ADR_ADR                               CVMX_ADD_IO_SEG(0x00011800A8000098ull)
#define  CVMX_TRA_TRIG0_ADR_MSK                               CVMX_ADD_IO_SEG(0x00011800A80000A0ull)
#define  CVMX_TRA_TRIG0_CMD                                   CVMX_ADD_IO_SEG(0x00011800A8000080ull)
#define  CVMX_TRA_TRIG0_DID                                   CVMX_ADD_IO_SEG(0x00011800A8000090ull)
#define  CVMX_TRA_TRIG0_SID                                   CVMX_ADD_IO_SEG(0x00011800A8000088ull)
#define  CVMX_TRA_TRIG1_ADR_ADR                               CVMX_ADD_IO_SEG(0x00011800A80000D8ull)
#define  CVMX_TRA_TRIG1_ADR_MSK                               CVMX_ADD_IO_SEG(0x00011800A80000E0ull)
#define  CVMX_TRA_TRIG1_CMD                                   CVMX_ADD_IO_SEG(0x00011800A80000C0ull)
#define  CVMX_TRA_TRIG1_DID                                   CVMX_ADD_IO_SEG(0x00011800A80000D0ull)
#define  CVMX_TRA_TRIG1_SID                                   CVMX_ADD_IO_SEG(0x00011800A80000C8ull)
#define  CVMX_USBC_DAINT                                      CVMX_ADD_IO_SEG(0x00016F0010000818ull)
#define  CVMX_USBC_DAINTMSK                                   CVMX_ADD_IO_SEG(0x00016F001000081Cull)
#define  CVMX_USBC_DCFG                                       CVMX_ADD_IO_SEG(0x00016F0010000800ull)
#define  CVMX_USBC_DCTL                                       CVMX_ADD_IO_SEG(0x00016F0010000804ull)
#define  CVMX_USBC_DIEPCTL0                                   CVMX_ADD_IO_SEG(0x00016F0010000900ull)
#define  CVMX_USBC_DIEPCTLX(offset)                          (CVMX_ADD_IO_SEG(0x00016F0010000920ull+((offset)*32)-32*1))
#define  CVMX_USBC_DIEPINTX(offset)                          (CVMX_ADD_IO_SEG(0x00016F0010000908ull+((offset)*32)))
#define  CVMX_USBC_DIEPMSK                                    CVMX_ADD_IO_SEG(0x00016F0010000810ull)
#define  CVMX_USBC_DIEPTSIZ0                                  CVMX_ADD_IO_SEG(0x00016F0010000910ull)
#define  CVMX_USBC_DIEPTSIZX(offset)                         (CVMX_ADD_IO_SEG(0x00016F0010000930ull+((offset)*32)-32*1))
#define  CVMX_USBC_DOEPCTL0                                   CVMX_ADD_IO_SEG(0x00016F0010000B00ull)
#define  CVMX_USBC_DOEPCTLX(offset)                          (CVMX_ADD_IO_SEG(0x00016F0010000B20ull+((offset)*32)-32*1))
#define  CVMX_USBC_DOEPINTX(offset)                          (CVMX_ADD_IO_SEG(0x00016F0010000B08ull+((offset)*32)))
#define  CVMX_USBC_DOEPMSK                                    CVMX_ADD_IO_SEG(0x00016F0010000814ull)
#define  CVMX_USBC_DOEPTSIZ0                                  CVMX_ADD_IO_SEG(0x00016F0010000B10ull)
#define  CVMX_USBC_DOEPTSIZX(offset)                         (CVMX_ADD_IO_SEG(0x00016F0010000B30ull+((offset)*32)-32*1))
#define  CVMX_USBC_DPTXFSIZX(offset)                         (CVMX_ADD_IO_SEG(0x00016F0010000104ull+((offset)*4)-4*1))
#define  CVMX_USBC_DSTS                                       CVMX_ADD_IO_SEG(0x00016F0010000808ull)
#define  CVMX_USBC_DTKNQR1                                    CVMX_ADD_IO_SEG(0x00016F0010000820ull)
#define  CVMX_USBC_DTKNQR2                                    CVMX_ADD_IO_SEG(0x00016F0010000824ull)
#define  CVMX_USBC_DTKNQR3                                    CVMX_ADD_IO_SEG(0x00016F0010000830ull)
#define  CVMX_USBC_DTKNQR4                                    CVMX_ADD_IO_SEG(0x00016F0010000834ull)
#define  CVMX_USBC_GAHBCFG                                    CVMX_ADD_IO_SEG(0x00016F0010000008ull)
#define  CVMX_USBC_GHWCFG1                                    CVMX_ADD_IO_SEG(0x00016F0010000044ull)
#define  CVMX_USBC_GHWCFG2                                    CVMX_ADD_IO_SEG(0x00016F0010000048ull)
#define  CVMX_USBC_GHWCFG3                                    CVMX_ADD_IO_SEG(0x00016F001000004Cull)
#define  CVMX_USBC_GHWCFG4                                    CVMX_ADD_IO_SEG(0x00016F0010000050ull)
#define  CVMX_USBC_GINTMSK                                    CVMX_ADD_IO_SEG(0x00016F0010000018ull)
#define  CVMX_USBC_GINTSTS                                    CVMX_ADD_IO_SEG(0x00016F0010000014ull)
#define  CVMX_USBC_GNPTXFSIZ                                  CVMX_ADD_IO_SEG(0x00016F0010000028ull)
#define  CVMX_USBC_GNPTXSTS                                   CVMX_ADD_IO_SEG(0x00016F001000002Cull)
#define  CVMX_USBC_GOTGCTL                                    CVMX_ADD_IO_SEG(0x00016F0010000000ull)
#define  CVMX_USBC_GOTGINT                                    CVMX_ADD_IO_SEG(0x00016F0010000004ull)
#define  CVMX_USBC_GRSTCTL                                    CVMX_ADD_IO_SEG(0x00016F0010000010ull)
#define  CVMX_USBC_GRXFSIZ                                    CVMX_ADD_IO_SEG(0x00016F0010000024ull)
#define  CVMX_USBC_GRXSTSPD                                   CVMX_ADD_IO_SEG(0x00016F0010040020ull)
#define  CVMX_USBC_GRXSTSPH                                   CVMX_ADD_IO_SEG(0x00016F0010000020ull)
#define  CVMX_USBC_GRXSTSRD                                   CVMX_ADD_IO_SEG(0x00016F001004001Cull)
#define  CVMX_USBC_GRXSTSRH                                   CVMX_ADD_IO_SEG(0x00016F001000001Cull)
#define  CVMX_USBC_GSNPSID                                    CVMX_ADD_IO_SEG(0x00016F0010000040ull)
#define  CVMX_USBC_GUSBCFG                                    CVMX_ADD_IO_SEG(0x00016F001000000Cull)
#define  CVMX_USBC_HAINT                                      CVMX_ADD_IO_SEG(0x00016F0010000414ull)
#define  CVMX_USBC_HAINTMSK                                   CVMX_ADD_IO_SEG(0x00016F0010000418ull)
#define  CVMX_USBC_HCCHARX(offset)                           (CVMX_ADD_IO_SEG(0x00016F0010000500ull+((offset)*32)))
#define  CVMX_USBC_HCFG                                       CVMX_ADD_IO_SEG(0x00016F0010000400ull)
#define  CVMX_USBC_HCINTMSKX(offset)                         (CVMX_ADD_IO_SEG(0x00016F001000050Cull+((offset)*32)))
#define  CVMX_USBC_HCINTX(offset)                            (CVMX_ADD_IO_SEG(0x00016F0010000508ull+((offset)*32)))
#define  CVMX_USBC_HCSPLTX(offset)                           (CVMX_ADD_IO_SEG(0x00016F0010000504ull+((offset)*32)))
#define  CVMX_USBC_HCTSIZX(offset)                           (CVMX_ADD_IO_SEG(0x00016F0010000510ull+((offset)*32)))
#define  CVMX_USBC_HFIR                                       CVMX_ADD_IO_SEG(0x00016F0010000404ull)
#define  CVMX_USBC_HFNUM                                      CVMX_ADD_IO_SEG(0x00016F0010000408ull)
#define  CVMX_USBC_HPRT                                       CVMX_ADD_IO_SEG(0x00016F0010000440ull)
#define  CVMX_USBC_HPTXFSIZ                                   CVMX_ADD_IO_SEG(0x00016F0010000100ull)
#define  CVMX_USBC_HPTXSTS                                    CVMX_ADD_IO_SEG(0x00016F0010000410ull)
#define  CVMX_USBC_NPTXDFIFOX(offset)                        (CVMX_ADD_IO_SEG(0x00016F0010001000ull+((offset)*4096)))
#define  CVMX_USBC_PCGCCTL                                    CVMX_ADD_IO_SEG(0x00016F0010000E00ull)
#define  CVMX_USBN_BIST_STATUS                                CVMX_ADD_IO_SEG(0x00011800680007F8ull)
#define  CVMX_USBN_CLK_CTL                                    CVMX_ADD_IO_SEG(0x0001180068000010ull)
#define  CVMX_USBN_CTL_STATUS                                 CVMX_ADD_IO_SEG(0x00016F0000000800ull)
#define  CVMX_USBN_DMA0_INB_CHN0                              CVMX_ADD_IO_SEG(0x00016F0000000818ull)
#define  CVMX_USBN_DMA0_INB_CHN1                              CVMX_ADD_IO_SEG(0x00016F0000000820ull)
#define  CVMX_USBN_DMA0_INB_CHN2                              CVMX_ADD_IO_SEG(0x00016F0000000828ull)
#define  CVMX_USBN_DMA0_INB_CHN3                              CVMX_ADD_IO_SEG(0x00016F0000000830ull)
#define  CVMX_USBN_DMA0_INB_CHN4                              CVMX_ADD_IO_SEG(0x00016F0000000838ull)
#define  CVMX_USBN_DMA0_INB_CHN5                              CVMX_ADD_IO_SEG(0x00016F0000000840ull)
#define  CVMX_USBN_DMA0_INB_CHN6                              CVMX_ADD_IO_SEG(0x00016F0000000848ull)
#define  CVMX_USBN_DMA0_INB_CHN7                              CVMX_ADD_IO_SEG(0x00016F0000000850ull)
#define  CVMX_USBN_DMA0_OUTB_CHN0                             CVMX_ADD_IO_SEG(0x00016F0000000858ull)
#define  CVMX_USBN_DMA0_OUTB_CHN1                             CVMX_ADD_IO_SEG(0x00016F0000000860ull)
#define  CVMX_USBN_DMA0_OUTB_CHN2                             CVMX_ADD_IO_SEG(0x00016F0000000868ull)
#define  CVMX_USBN_DMA0_OUTB_CHN3                             CVMX_ADD_IO_SEG(0x00016F0000000870ull)
#define  CVMX_USBN_DMA0_OUTB_CHN4                             CVMX_ADD_IO_SEG(0x00016F0000000878ull)
#define  CVMX_USBN_DMA0_OUTB_CHN5                             CVMX_ADD_IO_SEG(0x00016F0000000880ull)
#define  CVMX_USBN_DMA0_OUTB_CHN6                             CVMX_ADD_IO_SEG(0x00016F0000000888ull)
#define  CVMX_USBN_DMA0_OUTB_CHN7                             CVMX_ADD_IO_SEG(0x00016F0000000890ull)
#define  CVMX_USBN_DMA_TEST                                   CVMX_ADD_IO_SEG(0x00016F0000000808ull)
#define  CVMX_USBN_INT_ENB                                    CVMX_ADD_IO_SEG(0x0001180068000008ull)
#define  CVMX_USBN_INT_SUM                                    CVMX_ADD_IO_SEG(0x0001180068000000ull)
#define  CVMX_USBN_USBP_CTL_STATUS                            CVMX_ADD_IO_SEG(0x0001180068000018ull)
#define  CVMX_ZIP_CMD_BIST_RESULT                             CVMX_ADD_IO_SEG(0x0001180038000080ull)
#define  CVMX_ZIP_CMD_BUF                                     CVMX_ADD_IO_SEG(0x0001180038000008ull)
#define  CVMX_ZIP_CMD_CTL                                     CVMX_ADD_IO_SEG(0x0001180038000000ull)
#define  CVMX_ZIP_CONSTANTS                                   CVMX_ADD_IO_SEG(0x00011800380000A0ull)
#define  CVMX_ZIP_DEBUG0                                      CVMX_ADD_IO_SEG(0x0001180038000098ull)
#define  CVMX_ZIP_ERROR                                       CVMX_ADD_IO_SEG(0x0001180038000088ull)
#define  CVMX_ZIP_INT_MASK                                    CVMX_ADD_IO_SEG(0x0001180038000090ull)

#endif /* __CVMX_CSR_PASS2_H__ */
