/* lanGroups.js - API library for lanGroups page */

/* Copyright 2010 TeamF1, Inc. */

/*
modification history 
------------------------
01c,14MAR11,mvb modified lanGroupsValidate(), added new check for Groupip is in LAN Subnet or not.
01b,7MAR11,mvb modified added isProblemcharArrayCheck for GroupName.
01a,29SEP10,vds  written. 
*/

function lanGroupsValidate ()
    {
    /* L10N Error Message Collection Start */
    var errMsgL10n1 = 'Please enter a valid name for the PC or device to be added';
    var errMsgL10n2 = 'Please enter a valid MAC address in the form XX:XX:XX:XX:XX:XX for the PC or device to be added';
    var errMsgL10n3 = 'Invalid IP address for the PC or device to be added.';   
    var errMsgL10n4 = 'for octet'; 
    var errMsgObjL10n = document.getElementById ('hd.valPcName');
    if (errMsgObjL10n) errMsgL10n1 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.macFrmtErrFrPc');
    if (errMsgObjL10n) errMsgL10n2 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.invalIpAddrPc');
    if (errMsgObjL10n) errMsgL10n3 = errMsgObjL10n.value;
    errMsgObjL10n = document.getElementById ('hd.foroctate');
    if (errMsgObjL10n) errMsgL10n4= errMsgObjL10n.value;
     /* L10N Error Message Collection End */
    
    var txtFieldIdArr = new Array ();    
    txtFieldIdArr[0] = "txtLanGroupsName," +
                       errMsgL10n1;
    txtFieldIdArr[1] = "txtLanGroupsMACAddr," + 
                       errMsgL10n2;
                       
    var txtGroupNameArr = new Array ();
    txtGroupNameArr[0] = "txtLanGroupsName,"+errMsgL10n1;
    
    if (txtFieldArrayCheck (txtFieldIdArr) == false)
         return false;
    if (isProblemCharArrayCheck(txtGroupNameArr) == false)
        return false;
    if (ipv4AddrOctetsValidate ('tblIpAddr', 'IPD', false, true, 'Invalid IP address for the PC or device to be added.', errMsgL10n4+" ", true) == false)
        return false;
        
    var ipAddrObj = document.getElementById ('tblIpAddr');
    if (ipAddrObj && ipAddrObj.disabled) return true;
    /*Begin:Subnet Checking for LAN*/
    if(ipAddrObj && !ipAddrObj.disabled)
        {
        var i = 0;
        var l2tpCurIp = getIPInt('tblIpAddr');
        var l2tpIPObj = document.getElementById('tblIpAddr');
        var numObj = document.getElementById('hdNum');
        var numObjVal = parseInt(numObj.value,10);
        var intIP = "";
        var intIpMask = "";
        var flag = 0;
        var hdValObj = document.getElementById('hdVlanName');
        if(numObj)
            {
            while (i <= numObjVal)
                {
                i= i + 1;
                intIPId = "hdIpAddr"+i;
                intIPMaskId = "hdSnet"+i;
                if(document.getElementById(intIPId))
                    {
                    var intIp = getIPInt1(intIPId);
                    var intIpMask = getIPInt1(intIPMaskId);
                    if(document.getElementById(intIPId).value != '0.0.0.0' && document.getElementById(intIPMaskId).value != '0.0.0.0')
                        {
                        if(isInSubnet(l2tpCurIp, intIp, intIpMask))
                            {
                            if(i == hdValObj.value)
                                {
                                flag = flag + 1;
                                break;
                                }
                            }
                        }
                    }
                }
            }
          if(flag == 0)
              {
              var errorstr = "IP Address should be in Selected LAN/VLAN subnet.";
              alert (errorstr)
              l2tpIPObj.focus();
              return false;
              }                  
           else
              {
              var countObj = document.getElementById('hdCount');              
              /*Begin:Subnet Checking for lo interface*/
              var ipAddr_Lo = getIPInt1('loIpAddr');
              var subnet_Lo = getIPInt1('loSnet');
              if (isInSubnetWithBroadCastIp(l2tpCurIp , ipAddr_Lo, subnet_Lo))
                  {
                  var errorstr = "Local interface IP address is in the same subnet. Please specify IP address in a different subnet.";
                  alert (errorstr);
                  l2tpIPObj.focus();
                  return false;
                  }
              /*End:Subnet Checking for lo interface*/
              if(countObj )
              {
              var countObjVal = parseInt(countObj.value,10);
              var i = 0;
              while (i <= countObjVal)
                {
                i= i + 1;
                intIPId = "hdIp"+i;                
                if(document.getElementById(intIPId))
                    {                    
                    var ipAddr = getIPStr('tblIpAddr');
                    if(document.getElementById(intIPId).value != '0.0.0.0' && document.getElementById(intIPId).value != '' && document.getElementById(intIPId).value == ipAddr)
                        {
                             var errorstr = "IP Address is in use. Please configure another IP Address."
                             alert(errorstr);
                             l2tpIPObj.focus();
                             return false;
                        }
                    }
                }
              }
            }               
        }
    /*End:Subnet and LAN/WAN/DMZ Ip Check Checking for LAN*/


    /* get and validate port */
    macObj = document.getElementById('txtLanGroupsMACAddr');
    if (!macObj || macObj.disabled) return true;
    if (!(macAddrValidate (macObj.value, true, "Invalid MAC address:", '')))
        {
        macObj.focus ();
        return false;
        }    
    return true; 
    }

function UpdateKey (form, keyVal)
    {
    form.web0x160001.value = keyVal;
    }


function vlanNameCheck()
    {
    var selValObj = document.getElementById('profileNameSel');
    var hdValObj = document.getElementById('hdVlanName');
	var selVal = (selValObj.options.selectedIndex);
	selVal = selVal + 1;
	hdValObj.value = selVal;
	//alert(hdValObj.value);
    }    
