/* lan_wan.js - API library for LAN WAN configuration */

/* Copyright 2011 - 2013 TeamF1, Inc. */

function dropFieldSelectPublicDstAddr ()
	{
	var selObj = document.getElementById('selPublicDstIpAddr');
	if (selObj.disable) return;
   	var optVal = selObj.options[selObj.selectedIndex].value;
   	switch (optVal)
   		{
   		case 'RANGE':
   			fieldStateChangeWr ('', '', '', 'tblLwInPublicDstIpAddr tblLwInPublicDstIpAddr2');
   			break;
   		//case 'OTHER':
   			//fieldStateChangeWr ('', 'tblLwInPublicDstIpAddr2', '', 'tblLwInPublicDstIpAddr');
   			//break;   				
   		default:
   			fieldStateChangeWr ('', 'tblLwInPublicDstIpAddr tblLwInPublicDstIpAddr2', '', '');
   			break;
   		}
	}

function checkLanSvrOption()
	{
	var selObj = document.getElementById ('selSendLanSvr');
	if (!selObj) return;
	if (selObj.disabled)
		fieldStateChangeWr ('hdSelWanIpAddrType', 'tblLwInLanServer tblLwInLanServer2', 'selPublicDstIpAddr', '');
	if (parseInt (selObj.value, 10) == 1)
		fieldStateChangeWr ('hdSelWanIpAddrType', 'tblLwInLanServer2', 'selPublicDstIpAddr', 'tblLwInLanServer');
	else if (parseInt (selObj.value, 10) == 2)
		{
		fieldStateChangeWr ('', '', '', 'tblLwInLanServer tblLwInLanServer2');
		var wanDstObj = document.getElementById ('selPublicDstIpAddr');
		if (!wanDstObj) return;
	    var wanDestLength = wanDstObj.options.length;
		wanDstObj.selectedIndex = parseInt(wanDestLength,10)-1;    
		dropFieldSelectPublicDstAddr ();
		fieldStateChangeWr ('selPublicDstIpAddr', '', 'hdSelWanIpAddrType', '');
		}
	}
	
function checkAddressRange ()
	{
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Range mismatch in WAN Destination IP addresses and LAN server IP addresses';

     /* L10N Error Message Collection End */
     
	var selObj = document.getElementById ('selSendLanSvr');
	if (!selObj) return true;
	if (selObj.disabled || selObj.value != "2") return true;
	var lanAddressRange = 0;
	var wanAddressRange = 0;
	var lanSvrStartInt = getIPInt('tblLwInLanServer');
	var lanSvrEndInt = getIPInt('tblLwInLanServer2');
	lanAddressRange = lanSvrEndInt - lanSvrStartInt;
	
	var wanSvrStartInt = getIPInt('tblLwInPublicDstIpAddr');
	var wanSvrEndInt = getIPInt('tblLwInPublicDstIpAddr2');
	wanAddressRange = wanSvrEndInt - wanSvrStartInt;
	
	if (lanAddressRange != wanAddressRange)
		{
		alert (errMsgL10n1);
		return false;
		}

	return true;
	}

/* add_lw_in_service.htm Start */
function fwAddLwInServicesValidate ()
    {
    /* L10N Error Message Collection Start */
     var errMsgL10n1 ='Invalid port number - Please enter value between 0 - 65535.';
     var errMsgL10n2 ='Invalid port number';
     var errMsgL10n3 ='Invalid Start LAN server IP address.';
     var errMsgL10n4 ='for octet';
     var errMsgL10n5 ='Invalid LAN users starting IP address.';
     var errMsgL10n6 ='Invalid LAN users ending IP address.';
     var errMsgL10n7 ='LAN Users';
     var errMsgL10n8 ='Invalid WAN users starting IP address.';
     var errMsgL10n9 ='Invalid WAN users ending IP address.';
     var errMsgL10n10 ='WAN Users';
     var errMsgL10n11 ='Invalid End LAN server IP address.';
     var errMsgL10n12 ='LAN server IP address.';
     var errMsgL10n13 ='Invalid Start WAN Destination IP Address.';
     var errMsgL10n14 ='Invalid End WAN Destination IP Address.';
     var errMsgL10n15 ='WAN Destination IP Address.';
     /* L10N Error Message Collection End */

	obj = document.getElementById('txtTranslatePortNum');
    if (obj && !obj.disabled)
    {
	if (portValueRangeCheck (obj, 0, 65535, '', null, true, 'Invalid port number.') == false)
        return false;
	}
	if (ipv4AddrOctetsValidate ('tblLwInLanServer', 'IPD', false, true,
             errMsgL10n3, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblLwInLanServer2', 'IPD', false, true,
             errMsgL10n11, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('tblLwInLanServer','tblLwInLanServer2', errMsgL10n12) == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblLwInPublicDstIpAddr', 'IPD', false, true,
             errMsgL10n13, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('tblLwInPublicDstIpAddr2', 'IPD', false, true,
             errMsgL10n14, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('tblLwInPublicDstIpAddr','tblLwInPublicDstIpAddr2', errMsgL10n15) == false)
		return false;
	if (checkAddressRange () == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLWInLanUserStart', 'IPD', false, true,
             errMsgL10n5, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLWInLanUserFinish', 'IPD', false, true,
             errMsgL10n6, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('addLWInLanUserStart','addLWInLanUserFinish', errMsgL10n7) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLWInWanUserStart', 'IPD', false, true,
             errMsgL10n8, errMsgL10n4+" ", true) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLWInWanUserFinish', 'IPD', false, true,
             errMsgL10n9, errMsgL10n4+" ", true) == false)
		return false;
	if (ipRangeValidate ('addLWInWanUserStart','addLWInWanUserFinish', errMsgL10n10) == false)
		return false;
	return true;	
    }
    
function fwActionCheckLW ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');	
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHED_MATCH":
        case "DROP_BY_SCHED_MATCH":
            fieldStateChangeWr ('','','selSchedule selQos selSendLanSvr selBandwidthProfile','');
			checkLanSvrOption ();
			break;
		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','selBandwidthProfile selQos selSendLanSvr','');
			checkLanSvrOption ();
			break;
		case "DROP":	
		default:
			fieldStateChangeWr ('selSchedule selBandwidthProfile selQos selSendLanSvr hdSelWanIpAddrType','tblLwInLanServer tblLwInLanServer2','selPublicDstIpAddr','');
			break;
		}
	/* check for NAT mode */
	var fldObj = document.getElementById('hdNATState');
	if (parseInt (fldObj.value, 10) == 0)	/* CLASSICAL ROUTING */
		fieldStateChangeWr ('selSendLanSvr selPublicDstIpAddr hdSelWanIpAddrType', 'tblLwInLanServer tblLwInLanServer2 tblLwInPublicDstIpAddr tblLwInPublicDstIpAddr2', '', '');
	}
    
function dropFieldSelectLanLW (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLWInLanUserFinish', '', 'addLWInLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLWInLanUserStart addLWInLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLWInLanUserStart addLWInLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWanLW (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLWInWanUserFinish', '', 'addLWInWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLWInWanUserStart addLWInWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLWInWanUserStart addLWInWanUserFinish', '', '');
   			break;
   		}
    }
    
function InitialSettingsLW ()
	{
	fwActionCheckLW ();	
	var fldObj = document.getElementById('hdNATState');	
	if (parseInt (fldObj.value, 10) == 0)
		fieldStateChangeWr ('chkTranslatePortNum txtTranslatePortNum selPublicDstIpAddr hdSelWanIpAddrType', 'tblLwInLanServer tblLwInPublicDstIpAddr tblLwInPublicDstIpAddr2', '', '');
	else
		{
		serviceCheck ();
		//translatePortNumCheckLW ();
		dropFieldSelectPublicDstAddr ();
		fieldStateChangeWr ('addLWInLanUser', 'addLWInLanUserStart addLWInLanUserFinish', '', '');
		}
	
	var fldObj = document.getElementById('addLWInLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLanLW (fldObj);
	var fldObj = document.getElementById('addLWInWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWanLW (fldObj);
	}	

function serviceCheck ()
	{
	var selServiceValue = comboSelectedValueGet  ('selService');
	if (!selServiceValue) return;
	switch (selServiceValue)
		{
		case "ANY":
            fieldStateChangeWr ('chkTranslatePortNum txtTranslatePortNum','','','');
			break;
			
		default:
            fieldStateChangeWr ('','','chkTranslatePortNum txtTranslatePortNum','');
            translatePortNumCheck ();
			break;
		}
	}
	
/* add_lw_in_service.htm End */

/* add_lw_out_service.htm Start */
function fwAddLwOutServicesValidate ()
    {
     /* L10N Error Message Collection Start */     
     var errMsgL10n4 ='for octet';
     var errMsgL10n5 ='Invalid starting IP address for LAN users.';
     var errMsgL10n6 ='Invalid ending IP address for LAN users.';
     var errMsgL10n7 ='LAN Users';
     var errMsgL10n8 ='Invalid starting IP address for WAN users.';
     var errMsgL10n9 ='Invalid ending IP address for WAN users.';
     var errMsgL10n10 ='WAN Users';
      /* L10N Error Message Collection End */
          
	if (ipv4AddrOctetsValidate ('addLWOutLanUserStart', 'IPD', false, true,
             errMsgL10n5, errMsgL10n4+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLWOutLanUserFinish', 'IPD', false, true,
             errMsgL10n6, errMsgL10n4+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLWOutLanUserStart','addLWOutLanUserFinish', errMsgL10n7) == false)
		return false;
	if (ipv4AddrOctetsValidate ('addLWOutWanUserStart', 'IPD', false, true,
             errMsgL10n8, errMsgL10n4+" ", true) == false)
	    return false;
	if (ipv4AddrOctetsValidate ('addLWOutWanUserFinish', 'IPD', false, true,
             errMsgL10n9, errMsgL10n4+" ", true) == false)
	    return false;
	if (ipRangeValidate ('addLWOutWanUserStart','addLWOutWanUserFinish', errMsgL10n10) == false)
		return false;
	//if (ipv4AddrOctetsValidate ('tblNATIPStart', 'IP', false, true,
             //"Invalid NAT IP address.", "for octet ", true) == false)
	    //return false;	
		
	return true;
    }
function fwActionCheck ()
	{
	var selectedValue = comboSelectedValueGet  ('selFwAction');
	var selNATIPObj = document.getElementById ('selNATIP');
	if (!selectedValue) return;
	switch (selectedValue)
		{
        case "ACCEPT_BY_SCHED_MATCH":
        case "DROP_BY_SCHED_MATCH":
			if (document.getElementById ('selSnat'))
                fieldStateChangeWr ('','','selSchedule selQos selNATIP selSnat selBandwidthProfile','');
			else
                fieldStateChangeWr ('','','selSchedule selQos selNATIP selBandwidthProfile','');
			//dropFieldSelectNAT (selNATIPObj);
			break;

		case "ACCEPT":
			fieldStateChangeWr ('selSchedule','','selBandwidthProfile','');
			if (document.getElementById ('selSnat'))			
                fieldStateChangeWr ('','','selQos selNATIP selSnat','');
			else
				fieldStateChangeWr ('','','selQos selNATIP','');			
			//dropFieldSelectNAT (selNATIPObj);
			break;
		default:
			if (document.getElementById ('selSnat'))		
                fieldStateChangeWr ('selSchedule selQos selBandwidthProfile selNATIP selSnat','','','');
			else				
				fieldStateChangeWr ('selSchedule selQos selBandwidthProfile selNATIP','','','');				
			break;
		}
	  //wanmode check	
	  var wanModeObj = document.getElementById('keyNatIpDisable');
	    if(wanModeObj.value == "0")
            fieldStateChangeWr ('selNATIP','', '', ''); 
	}
function dropFieldSelectLan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLWOutLanUserFinish', '', 'addLWOutLanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLWOutLanUserStart addLWOutLanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLWOutLanUserStart addLWOutLanUserFinish', '', '');
   			break;
   		}
	}
function dropFieldSelectWan (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
   			fieldStateChangeWr ('', 'addLWOutWanUserFinish', '', 'addLWOutWanUserStart');
   			break;
   		case '2':
   			fieldStateChangeWr ('', '', '', 'addLWOutWanUserStart addLWOutWanUserFinish');
   			break;
   		default:
   			fieldStateChangeWr ('', 'addLWOutWanUserStart addLWOutWanUserFinish', '', '');
   			break;
   		}
    }

function dropFieldSelectNAT (parent)
    {
    if (!parent)
        return;
   	var optVal = parent.options[parent.selectedIndex].value;
   	
   	switch (optVal)
   		{
   		case '1':
			if (document.getElementById ('selSnat'))   		
                fieldStateChangeWr ('', '', 'selSnat', 'tblNATIPStart');
   			else
   				fieldStateChangeWr ('', '', '', 'tblNATIPStart');
   			break;
   		default:
			if (document.getElementById ('selSnat'))   		   		
                fieldStateChangeWr ('selSnat', 'tblNATIPStart', '', '');
	   		else
	   			fieldStateChangeWr ('', 'tblNATIPStart', '', '');	   		
   			break;
   		}
    }

function InitialSettings ()
	{
	fwActionCheck ();
	var fldObj = document.getElementById('addLWOutLanUser');
	if (!(fldObj.disable))
		dropFieldSelectLan (fldObj);
	var fldObj = document.getElementById('addLWOutWanUser');
	if (!(fldObj.disable))
		dropFieldSelectWan (fldObj);
	//var fldObj = document.getElementById('selNATIP');
	//if (!(fldObj.disable))
		//dropFieldSelectNAT (fldObj);
	}
	
function wanModeCheck ()
{
	var wanModeObj = document.getElementById('keyNatIpDisable');
	if(wanModeObj.value == "0")
            fieldStateChangeWr ('selNATIP','', '', '');
	var primWanObj = document.getElementById('hdPrimWan');            
	if (primWanObj.value == "0")
	{
		primWanObj.value = 1;
		if (document.getElementById ('selSnat'))
            optionValueSelect ('selSnat', 'hdPrimWan');            		
		primWanObj.value = 0;
	}
	else if (primWanObj.value == "1")
	{
		primWanObj.value = 2;
		if (document.getElementById ('selSnat'))		
            optionValueSelect ('selSnat', 'hdPrimWan');
		primWanObj.value = 1;
	}
}

